
#include "calCred.h"
#include "set.h"
#include "mechDistortion.h"

int isOrgEqTupleMatchGenEqTuple_dim(dimension *orgDim, dimension *genDim, generalizedDimTable *genDimTable)
{
	int returnValue;

	int noOfLevel;

	int level;

	dimension *tempDim1;
	dimension *tempDim2;

	generalizedLevelTable *genLevelTable;
	generalizedLevelTable *gen;

	// clone the dimensions
	tempDim1 = (dimension *) malloc(sizeof(dimension));
	tempDim2 = (dimension *) malloc(sizeof(dimension));

	memcpy(tempDim1, orgDim, sizeof(dimension));
	memcpy(tempDim2, genDim, sizeof(dimension));

	noOfLevel = genDimTable->noOfLevel;
	gen = genDimTable->gen;

	// making to both to the same levels
	if (tempDim1->level > tempDim2->level)
	{
		while (tempDim1->level > tempDim2->level)
		{
			// generalize tempDim2
			level = tempDim2->level;
			genLevelTable = &(gen[level]);
			generalizeDimension(tempDim2, genLevelTable);

		}
	}
	else if (tempDim1->level < tempDim2->level)
	{
		while (tempDim1->level < tempDim2->level)
		{
			// generalize tempDim1
			level = tempDim1->level;
			genLevelTable = &(gen[level]);
			generalizeDimension(tempDim1, genLevelTable);
		}
	}

	// they have the same levels
	if (tempDim1->value == tempDim2->value)
	{
		returnValue = 1;
	}
	else
	{
		returnValue = 0;
	}

	free(tempDim1);
	free(tempDim2);

	return returnValue;
}

int isOrgEqTupleMatchGenEqTuple(equivalenceTuple *orgEqTuple, equivalenceTuple *genEqTuple, int noOfQID, generalizedAllTable *genAllTable)
{
	int returnValue;
	int i;
	int isMatch;

	dimension *orgContent;
	dimension *genContent;

	generalizedDimTable *genDimTable;

	orgContent = orgEqTuple->content;
	genContent = genEqTuple->content;

	returnValue = 1;
	for (i = 0; i < noOfQID; i++)
	{
		genDimTable = &(genAllTable->genDimTable[i]);

		isMatch = isOrgEqTupleMatchGenEqTuple_dim(&(orgContent[i]), &(genContent[i]), genDimTable);

		if (isMatch == 0)
		{
			returnValue = 0;
			break;
		}
	}

	return returnValue;
	
}


//eqTuple_isEqual(genEqTupleList[genEqID], orgEqTupleList[i]);
int eqTuple_isEqual(equivalenceTuple *anEqTuple1, equivalenceTuple *anEqTuple2, int noOfQID)
{
	int returnValue;

	dimension *dim1;
	dimension *dim2;

	int i;

	dim1 = anEqTuple1->content;
	dim2 = anEqTuple2->content;

	returnValue = 1;
	for (i = 0; i < noOfQID; i++)
	{
		if ((dim1[i].level != dim2[i].level) || (dim1[i].value != dim2[i].value))
		{
			returnValue = 0;
			break;
		}
	}

	return returnValue;
}

void findOrgEqClassMatchGenEqClass(int noOfQID, generalizedAllTable *genAllTable, equivalenceClass *orgEqClass, equivalenceClass *genEqClass, mySet ***allOrgEqClassList, mySet ***allGenEqClassList)
{
	int noOfOrgEqTuple;
	int noOfGenEqTuple;

	int i, j;

	int increment;

	equivalenceTuple **orgEqList;
	equivalenceTuple **genEqList;

	equivalenceTuple *orgAnEqTuple;
	equivalenceTuple *genAnEqTuple;

	mySet **orgEqClassList;
	mySet **genEqClassList;

	int isMatch, isEqual;

	//
	noOfOrgEqTuple = orgEqClass->noOfEqClass;
	orgEqList = orgEqClass->eqClass;

	// 
	noOfGenEqTuple = genEqClass->noOfEqClass;
	genEqList = genEqClass->eqClass;

	orgEqClassList = (mySet **) malloc(sizeof(mySet *)*noOfOrgEqTuple);
	genEqClassList = (mySet **) malloc(sizeof(mySet *)*noOfGenEqTuple);

	(*allOrgEqClassList) = orgEqClassList;
	(*allGenEqClassList) = genEqClassList;

	for (i = 0; i < noOfOrgEqTuple; i++)
	{
		orgEqClassList[i] = mySet_new();
	}
	for (i = 0; i < noOfGenEqTuple; i++)
	{
		genEqClassList[i] = mySet_new();

		genAnEqTuple = genEqList[i];
		genAnEqTuple->noOfAvaMember = genAnEqTuple->noOfMember;
	}

	// find ungen
	for (i = 0; i < noOfOrgEqTuple; i++)
	{
		orgAnEqTuple = orgEqList[i];
		orgAnEqTuple->noOfUnGenMember = 0;

		for (j = 0; j < noOfGenEqTuple; j++)
		{
			genAnEqTuple = genEqList[j];

			isEqual = eqTuple_isEqual(orgAnEqTuple, genAnEqTuple, noOfQID);
			if (isEqual == 1)
			{
				orgAnEqTuple->noOfUnGenMember += genAnEqTuple->noOfMember;
				genAnEqTuple->noOfAvaMember = 0;
			}
		}
	}

	for (i = 0; i < noOfOrgEqTuple; i++)
	{
		orgAnEqTuple = orgEqList[i];
		orgAnEqTuple->noOfGenMember = 0;

		for (j = 0; j < noOfGenEqTuple; j++)
		{
			genAnEqTuple = genEqList[j];

			

			isMatch = isOrgEqTupleMatchGenEqTuple(orgAnEqTuple, genAnEqTuple, noOfQID, genAllTable);

			if (isMatch == 1)
			{
				// insert j into orgEqClassList[i]
				mySet_insert(orgEqClassList[i], j);

				// insert i into genEqClassList[j]
				mySet_insert(genEqClassList[j], i);

				isEqual = eqTuple_isEqual(orgAnEqTuple, genAnEqTuple, noOfQID);
				if (isEqual == 0)
				{
					if (genAnEqTuple->noOfAvaMember > 0)
					{
						increment = 0;
						if (orgAnEqTuple->noOfUnGenMember + orgAnEqTuple->noOfGenMember + genAnEqTuple->noOfAvaMember > orgAnEqTuple->noOfMember)
						{
							increment = orgAnEqTuple->noOfMember - orgAnEqTuple->noOfGenMember - orgAnEqTuple->noOfUnGenMember;
						}
						else
						{
							increment = genAnEqTuple->noOfAvaMember;
						}

						orgAnEqTuple->noOfGenMember += increment;
						genAnEqTuple->noOfAvaMember -= increment;
					}
				}
			}
		}
	}
}



vInputOutput *vInputOutput_new()
{
	vInputOutput *returnValue;

	returnValue = (vInputOutput *) malloc(sizeof(vInputOutput));
	memset(returnValue, 0, sizeof(vInputOutput));

	return returnValue;
}

void vInputOutput_free(vInputOutput *aVInputOutput)
{
	if (aVInputOutput->noOfElt > 0)
	{
		if (aVInputOutput->elt != NULL)
		{
			free(aVInputOutput->elt);
		}
		if (aVInputOutput->probability != NULL)
		{
			free(aVInputOutput->probability);
		}
	}
}

vInputOutput *vInputOutput_clone(vInputOutput *aVInputOutput)
{
	vInputOutput *returnValue;
	int noOfElt;

	returnValue = vInputOutput_new();

	noOfElt = aVInputOutput->noOfElt;
	if (noOfElt > 0)
	{
		

		if (aVInputOutput->elt != NULL)
		{
			returnValue->elt = (int *) malloc(sizeof(int)*noOfElt);
			memcpy(returnValue->elt, aVInputOutput->elt, sizeof(int)*noOfElt);
		}

		if (aVInputOutput->probability != NULL)
		{
			returnValue->probability = (double  *) malloc(sizeof(double)*noOfElt);
			memcpy(returnValue->probability, aVInputOutput->probability, sizeof(double)*noOfElt);
		}
	}

	return returnValue;
}



vInputOutput *marshalGenEquivalenceTuple2VInputOutput(equivalenceTuple *genEqTuple, int noOfChildren, int *children)
{
	vInputOutput *returnValue;

	returnValue = vInputOutput_new();

	returnValue->n_P = genEqTuple->noOfMember;
	returnValue->n_Psen = genEqTuple->noOfSen;

	returnValue->noOfElt = noOfChildren;
	returnValue->elt = (int *) malloc(sizeof(int)*noOfChildren);
	memcpy(returnValue->elt, children, sizeof(int)*noOfChildren);

	return returnValue;
}

vInputOutput **generateAllPossCaseForChildren(equivalenceTuple *genEqTuple, equivalenceClass *orgEqClass, mySet *genEqClassList, int *noOfCase)
{
	vInputOutput **returnValue;
	int n_P;

	int noOfOrgEqTuple;
	equivalenceTuple **orgEqList;
	equivalenceTuple *anEqTuple;

	int eqID;

	int i;

	int sum;

	int noOfChildren;
	int *children;

	int extra;

	(*noOfCase) = 0;

	noOfOrgEqTuple = orgEqClass->noOfEqClass;
	orgEqList = orgEqClass->eqClass;

	n_P = genEqTuple->noOfMember;

	sum = 0;
	for (i = 0; i < genEqClassList->noOfElt; i++)
	{
		eqID = genEqClassList->elt[i];

		anEqTuple = orgEqList[eqID];

		//sum += anEqTuple->noOfGenMember;
		sum += anEqTuple->noOfMember;
	}

	if (genEqClassList->noOfElt == 1)
	{
		// special case (ground value)
		(*noOfCase) = 1;
		returnValue = (vInputOutput **) malloc(sizeof(vInputOutput *));

		noOfChildren = 0;

		returnValue[0] = vInputOutput_new();

		/*noOfChildren = genEqClassList->noOfElt;
		children = (int *) malloc(sizeof(int)*noOfChildren);

		for (i = 0; i < noOfChildren; i++)
		{
			eqID = genEqClassList->elt[i];

			anEqTuple = orgEqList[eqID];

			children[i] = anEqTuple->noOfGenMember;
		}


		returnValue[0] = marshalGenEquivalenceTuple2VInputOutput(genEqTuple, noOfChildren, children);

		free(children);*/

	}
	else
	{
		if (n_P == sum)
		{
			// good case
			(*noOfCase) = 1;
			returnValue = (vInputOutput **) malloc(sizeof(vInputOutput *));

			noOfChildren = genEqClassList->noOfElt;
			children = (int *) malloc(sizeof(int)*noOfChildren);

			for (i = 0; i < noOfChildren; i++)
			{
				eqID = genEqClassList->elt[i];

				anEqTuple = orgEqList[eqID];

				//children[i] = anEqTuple->noOfGenMember;
				children[i] = anEqTuple->noOfMember;
			}

			returnValue[0] = marshalGenEquivalenceTuple2VInputOutput(genEqTuple, noOfChildren, children);

			free(children);
		}
		else
		{
			if (sum > n_P)
			{
				// multiple cases
				(*noOfCase) = 0;

				extra = sum - n_P;

				// assume only one case
				(*noOfCase) = 1;
				returnValue = (vInputOutput **) malloc(sizeof(vInputOutput *));

				noOfChildren = genEqClassList->noOfElt;
				children = (int *) malloc(sizeof(int)*noOfChildren);

				sum = 0;
				for (i = 0; i < noOfChildren; i++)
				{
					eqID = genEqClassList->elt[i];

					anEqTuple = orgEqList[eqID];

				/*	if (sum + anEqTuple->noOfGenMember < n_P)
					{
						children[i] = anEqTuple->noOfGenMember;
						sum += anEqTuple->noOfGenMember;
					}
					else
					{
						if (sum == n_P)
						{
							children[i] = 0;
						}
						else
						{
							children[i] = n_P - sum;
							sum += (n_P - sum);
						}
					}
				*/
					children[i] = anEqTuple->noOfMember;
				}

				returnValue[0] = marshalGenEquivalenceTuple2VInputOutput(genEqTuple, noOfChildren, children);

				free(children);
			}
			else
			{
				returnValue = NULL;
			}
		}
		}

	return returnValue;
}



V_UNIT factorial(int n)
{
	V_UNIT returnValue;
	int i;

	returnValue = 1;
	for (i = 1; i <= n; i++)
	{
		returnValue *= i;
	}

	return returnValue;
}

V_UNIT calculateCombination(int n, int r)
{
	V_UNIT returnValue;
	int i;

	V_UNIT denumerator;

	if (n-r > r)
	{
		returnValue = 1;
		for (i = n-r+1; i <= n; i++)
		{
			returnValue *= i;
		}

		denumerator = factorial(r);

		returnValue = returnValue/denumerator;
	}
	else
	{
		returnValue = 1;
		for (i = r+1; i <= n; i++)
		{
			returnValue *= i;
		}

		denumerator = factorial(n-r);

		returnValue = returnValue/denumerator;
	}

	return returnValue;
}

V_UNIT calculateM(int a, int b, int x, int *elt, V_UNIT ***m)
{
	V_UNIT returnValue;
	V_UNIT temp;
	int n_a;

	int r;

	n_a = elt[a];

	returnValue = 0;
	if (a == b)
	{
		returnValue = 0;
		if ((x >= 0) && (x <= n_a))
		{
			returnValue = calculateCombination(n_a, x);
		}
	}
	else if (a < b)
	{
		returnValue = 0;
		for (r = 0; r <= n_a; r++)
		{
			if (x-r >= 0)
			{
				temp = calculateCombination(n_a, r);
				returnValue += temp*m[a+1][b][x-r];
			}
		}
	}

	return returnValue;
}

V_UNIT calculateU(int a, int b, int x, int d, int *elt, V_UNIT ***u)
{
	V_UNIT returnValue;
	int n_a;

	int r;

	int upperBound;

	n_a = elt[a];

	returnValue = 0;
	if (a == b)
	{
		returnValue = 0;
		upperBound = (int) floor(n_a/((double) d));
		if ((x >= 0) && (x <= upperBound))
		{
			returnValue = calculateCombination(n_a, x);
		}
	}
	else if (a < b)
	{
		returnValue = 0;
		upperBound = (int) floor(n_a/((double) d));
		for (r = 0; r <= upperBound; r++)
		{
			if (x-r >= 0)
			{
				returnValue += calculateCombination(n_a, r)*u[a+1][b][x-r];
			}
		}
	}

	return returnValue;
}

V_UNIT calculateN(int a, int b, int x, int d, int *elt, V_UNIT ***n, V_UNIT ***m)
{
	V_UNIT returnValue;
	int n_a;

	int r;

	int upperBound, lowerBound;

	n_a = elt[a];;

	returnValue = 0;
	if (a == b)
	{
		returnValue = 0;

		lowerBound = (int) floor(n_a/((double) d)) + 1;
		if ((x >= lowerBound) && (x <= n_a))
		{
			returnValue = calculateCombination(n_a, x);
		}
	}
	else if (a < b)
	{
		returnValue = 0;
		lowerBound = (int) floor(n_a/((double) d)) + 1;
		for (r = lowerBound; r <= n_a; r++)
		{
			if (x-r >= 0)
			{
				returnValue += calculateCombination(n_a, r)*m[a+1][b][x-r];
			}
		}

		upperBound = (int) floor(n_a/((double) d));
		for (r = 0; r <= upperBound; r++)
		{
			if (x-r >= 0)
			{
				returnValue += calculateCombination(n_a, r)*n[a+1][b][x-r];
			}
		}
	}

	return returnValue;

}


V_UNIT calculateB(int N, int n_S, int n1, int d, int p, V_UNIT ***n)
{
	V_UNIT returnValue;
	V_UNIT temp;
	int x;
	int lowerBound;

	lowerBound = (int) floor(n1/((double) d)) + 1;

	returnValue = 0;
	for (x = lowerBound; x <= n_S; x++)
	{
		if (n_S-x >= 0)
		{
			temp = calculateCombination(N, n_S-x);
			returnValue += n[0][p-1][x]*temp;
		}
	}

	return returnValue;
}


V_UNIT calculateA_one(int N, int n_S, int i, int j, int x, int n1, int d, int p, int *elt, V_UNIT ***n, V_UNIT ***m, V_UNIT ***u)
{
	V_UNIT returnValue;

	int lowerBound, upperBound;
	int r;

	int n_i;

	V_UNIT firstTerm, secondTerm, thirdTerm;

	n_i = elt[i];

	lowerBound = (int) floor(n_i/((double) d)) + 1;
	upperBound = (int) floor(n_i/((double) d));

	

	returnValue = 0;
	
	if ((j >= lowerBound) && (j <= n_i))
	{
		if (n_S-x >= 0)
		{
			firstTerm = calculateCombination(N, n_S-x);
			secondTerm = calculateCombination(n_i, j);
			if (i == 0)
			{
				r = 0;
				if (x-r-j >= 0)
				{
					if (i+1 > p-1)
					{
						thirdTerm = 1;
					}
					else
					{
						thirdTerm = m[i+1][p-1][x-r-j];
					}
				}
				else
				{
					thirdTerm = 0;
				}
			}
			else
			{
				
				if (i+1 > p-1)
				{
					r = x-j;
					if (r >= 0)
					{
						thirdTerm = m[0][i-1][r];
					}
					else
					{
						thirdTerm = 0;
					}
				}
				else
				{
					thirdTerm = 0;
					for (r = 0; r <= x-j; r++)
					{
						if (x-r-j >= 0)
						{
							thirdTerm += m[0][i-1][r]*m[i+1][p-1][x-r-j];
						}
					}
				}
			}

			returnValue = firstTerm*secondTerm*thirdTerm;
		}
		else
		{
			returnValue = 0;
		}

	}
	else if ((0 <= j) && (j <= upperBound))
	{
		if (n_S-x >= 0)
		{
			firstTerm = calculateCombination(N, n_S-x);
			secondTerm = calculateCombination(n_i, j);
			thirdTerm = 0;
			if (i == 0)
			{
				r = 0;
				if (x-r-j >= 0)
				{
					if (i+1 > p-1)
					{
						thirdTerm = 0;
					}
					else
					{
						thirdTerm = n[i+1][p-1][x-r-j];
					}
				}
				else
				{
					thirdTerm = 0;
				}
			}
			else
			{
				if (i+1 > p-1)
				{
					r = x-j;
					if (r >= 0)
					{
						thirdTerm = n[0][i-1][r];
					}
					else
					{
						thirdTerm = 0;
					}
				}
				else
				{
					for (r = 0; r <= x-j; r++)
					{
						if (x-r-j >= 0)
						{
							thirdTerm += n[0][i-1][r]*m[i+1][p-1][x-r-j] + u[0][i-1][r]*n[i+1][p-1][x-r-j];
						}
					}
				}
			}

			returnValue = firstTerm*secondTerm*thirdTerm;
		}
		else
		{
			returnValue = 0;
		}
	}

	return returnValue;
}

V_UNIT calculateA(int N, int n_S, int i, int j, int n1, int d, int p, int *elt, V_UNIT ***n, V_UNIT ***m, V_UNIT ***u)
{
	V_UNIT returnValue;
	V_UNIT temp;

	int x;
	int lowerBound;

	lowerBound = (int) floor(n1/((double) d)) + 1;

	returnValue = 0;
	for (x = lowerBound; x <= n_S; x++)
	{
		temp = calculateA_one(N, n_S, i, j, x, n1, d, p, elt, n, m, u);
		returnValue += temp;
	}

	return returnValue;
}

void calculateV(int d, vInputOutput *aVInputOutput)
{
	V_UNIT ***n;
	V_UNIT ***m;
	V_UNIT ***u;

	int n_S;

	int i, j;

	int *sorted_index;
	int *sorted_indexReverse;
	int noOfElt;

	int *value;
	int *valueReverse;

	int indexNo;

	int p;

	int a, b, x;

	int *newElt;

	double *probability;
	double A, B;
	double firstTerm;
	int N;
	int n1;

	int n_i;
	

	noOfElt = aVInputOutput->noOfElt;
	n_S = aVInputOutput->n_Psen;

	valueReverse = (int *) malloc(sizeof(int)*noOfElt);
	for (i = 0; i < noOfElt; i++)
	{
		valueReverse[i] = (int) floor(aVInputOutput->elt[i]/((double) d));
	}

	value = (int *) malloc(sizeof(int)*noOfElt);
	memset(value, 0, sizeof(int)*noOfElt);

	sorted_indexReverse = (int *) malloc(sizeof(int)*noOfElt);
	for (i = 0; i < noOfElt; i++)
	{
		sorted_indexReverse[i] = i;
	}

	sorted_index = (int *) malloc(sizeof(int)*noOfElt);
	memset(sorted_index, 0, sizeof(int)*noOfElt);

	// sort
	quicksort_i(sorted_indexReverse, valueReverse, 0, noOfElt-1);

	// reverse back
	for (i = 0;  i < noOfElt; i++)
	{
		sorted_index[i] = sorted_indexReverse[noOfElt-i-1];
		value[i] = valueReverse[noOfElt-i-1];
	}

	// free
	//free(valueReverse);
	//free(sorted_indexReverse);

	// create newElt
	newElt = (int *) malloc(sizeof(int)*noOfElt);
	memset(newElt, 0, sizeof(int)*noOfElt);
	for (i = 0; i < noOfElt; i++)
	{
		indexNo = sorted_index[i];	

		newElt[i] = aVInputOutput->elt[indexNo];
	}

	// find p and N
	p = 0;
	N = 0;
	for (i = 0; i < noOfElt; i++)
	{
		if (n_S > value[i])
		{
			p++;
		}
		else
		{
			N += newElt[i];
		}
	}

	if (p > 0)
	{
		// find n1
		n1 = value[0];

		

		// Initialize
		n = (V_UNIT ***) malloc(sizeof(V_UNIT **)*(p+1));
		m = (V_UNIT ***) malloc(sizeof(V_UNIT **)*(p+1));
		u = (V_UNIT ***) malloc(sizeof(V_UNIT **)*(p+1));

		for (i = 0; i < p+1; i++)
		{
			n[i] = (V_UNIT **) malloc(sizeof(V_UNIT *)*(p+1));
			m[i] = (V_UNIT **) malloc(sizeof(V_UNIT *)*(p+1));
			u[i] = (V_UNIT **) malloc(sizeof(V_UNIT *)*(p+1));
			

			for (j = 0; j < p+1; j++)
			{
				n[i][j] = (V_UNIT *) malloc(sizeof(V_UNIT)*(n_S+1));
				m[i][j] = (V_UNIT *) malloc(sizeof(V_UNIT)*(n_S+1));
				u[i][j] = (V_UNIT *) malloc(sizeof(V_UNIT)*(n_S+1));

				memset(n[i][j], 0, sizeof(V_UNIT)*(n_S+1));
				memset(m[i][j], 0, sizeof(V_UNIT)*(n_S+1));
				memset(u[i][j], 0, sizeof(V_UNIT)*(n_S+1));
			}
		}

		// calculate m and u
		for (x = 0; x <=n_S; x++)
		{
			for (a = p-1; a >= 0; a--)
			{
				for (b = a; b <= p-1; b++)
				{
if ((a == 1) && (b == 0) && (x == 0))
{
	printf("");
}
					m[a][b][x] = calculateM(a, b, x, newElt, m);
					u[a][b][x] = calculateU(a, b, x, d, newElt, u);
				}
			}
		}

		// calculate n
		for (x = 0; x <=n_S; x++)
		{
			for (a = p-1; a >= 0; a--)
			{
				for (b = a; b <= p-1; b++)
				{
if ((a == 0) && (b == p-1) && (x == 1))
{
	printf("");
}
					n[a][b][x] = calculateN(a, b, x, d, newElt, n, m);
				}
			}
		}

		probability = (double *) malloc(sizeof(double)*noOfElt);
		// calculate probability
		for (i = 0; i < p ; i++)
		{
			probability[i] = 0;

			n_i = newElt[i];
			for (j = 1; j <= n_i; j++)
			{
				A = calculateA(N, n_S, i, j, n1, d, p, newElt, n, m, u);
				B = calculateB(N, n_S, n1, d, p, n);
				firstTerm = A/B;

				probability[i] += firstTerm*j/((double) n_i);
			}
		}
		for (i = p; i < noOfElt; i++)
		{
			probability[i] = -1;
		}

		// map back
		aVInputOutput->probability = (double *) malloc(sizeof(double)*noOfElt);
		for (i = 0; i < noOfElt ; i++)
		{
			indexNo = sorted_index[i];

			aVInputOutput->probability[indexNo] = probability[i];
		}

		// free
		free(probability);

		// free
		for (i = 0; i < p; i++)
		{
			for (j = 0; j < p; j++)
			{
				free(n[i][j]);
				free(m[i][j]);
				free(u[i][j]);
			}
			free(n[i]);
			free(m[i]);
			free(u[i]);
		}
		free(n);
		free(m);
		free(u);

	}
	else
	{
		aVInputOutput->probability = (double *) malloc(sizeof(double)*noOfElt);
		if (noOfElt == 1)
		{
			// genEqTuple is a ground value
			i = 0;
			aVInputOutput->probability[i] = -2;
			// -2 indicates to use the original prob.
		}
		else
		{
			for (i = 0; i < noOfElt; i++)
			{
				aVInputOutput->probability[i] = -1;
			}
		}
	}

	//free(value);
	//free(sorted_index);

	free(newElt);
}



vInputOutput *calculateFunctionVForGenEqTuple(int d, equivalenceTuple *genEqTuple, equivalenceClass *orgEqClass, mySet *genEqClassList)
{
	vInputOutput *returnValue;
	vInputOutput **vInputOutputList;
	int noOfCase;

	int i;

	returnValue = vInputOutput_new();

	vInputOutputList = generateAllPossCaseForChildren(genEqTuple, orgEqClass, genEqClassList, &noOfCase);

	for (i = 0; i < noOfCase; i++)
	{
		calculateV(d, vInputOutputList[i]);
	}

	// assume only one case
	returnValue = vInputOutput_clone(vInputOutputList[0]);
	

	// free
	for (i = 0; i < noOfCase; i++)
	{
		vInputOutput_free(vInputOutputList[i]);
	}
	free(vInputOutputList);

	return returnValue;
}

vInputOutput **calculateFunctionVForGenEqClass(int d, equivalenceClass *genEqClass, equivalenceClass *orgEqClass, mySet **allGenEqClassList)
{
	vInputOutput **returnValue;

	int noOfGenEqTuple;
	equivalenceTuple **genEqList;

	int i;

	noOfGenEqTuple = genEqClass->noOfEqClass;
	genEqList = genEqClass->eqClass;

	returnValue = (vInputOutput **) malloc(sizeof(vInputOutput)*noOfGenEqTuple);

	for (i = 0; i < noOfGenEqTuple; i++)
	{
		if (i%1000 == 0)
		{
			printf("   Processing gen eq. tuple %d...\n", i);
		}
if (i == 1)
{
	printf("");
}
		returnValue[i] = calculateFunctionVForGenEqTuple(d, genEqList[i], orgEqClass, allGenEqClassList[i]);
	}

	return returnValue;
}

//-1: if not found
int findRelativeIndexInGenEqClassList(mySet *genEqClassList, int no)
{
	int returnValue;

	int i;

	returnValue = -1;

	for (i = 0; i < genEqClassList->noOfElt; i++)
	{
		if (no == genEqClassList->elt[i])
		{
			returnValue = i;
			break;
		}
	}
	return returnValue;
}


double *calculateCredibilityFromOrgEqClass(int noOfQID, equivalenceClass *orgEqClass, equivalenceClass *genEqClass, mySet **allOrgEqClassList, mySet **allGenEqClassList, vInputOutput **aOutput)
{
	double *returnValue;

	int noOfOrgEqTuple;
	equivalenceTuple **orgEqTupleList;

	mySet *orgEqClassList;

	int relativeIndex;

	int i, j;

	int genEqID;

	int noOfGenEqTuple;
	equivalenceTuple **genEqTupleList;

	double firstTerm, secondTerm;

	int isEqual;
	int noOfEqual;

	int *contributeCount;

	int equalIndex;
	int total;
	int allRemain;
	int increment;

	//int *contributeCount;

	noOfGenEqTuple = genEqClass->noOfEqClass;
	genEqTupleList = genEqClass->eqClass;

	

	noOfOrgEqTuple = orgEqClass->noOfEqClass;
	orgEqTupleList = orgEqClass->eqClass;

	returnValue = (double *) malloc(sizeof(double)*noOfOrgEqTuple);
	memset(returnValue, 0, sizeof(double)*noOfOrgEqTuple);

	for (i = 0; i < noOfOrgEqTuple; i++)
	{
if (i == 9)
{
	printf("");
}
		returnValue[i] = 0;

		orgEqClassList = allOrgEqClassList[i];

		// find exact
		noOfEqual = 0;
		for (j = 0; j < orgEqClassList->noOfElt; j++)
		{
			genEqID = orgEqClassList->elt[j];

			isEqual = eqTuple_isEqual(genEqTupleList[genEqID], orgEqTupleList[i], noOfQID);

			if (isEqual == 1)
			{
				noOfEqual = genEqTupleList[genEqID]->noOfMember;
				equalIndex = j;
				break;
			}
		}

		contributeCount = (int *) malloc(sizeof(int)*orgEqClassList->noOfElt);
		memset(contributeCount, 0, sizeof(int)*orgEqClassList->noOfElt);
		if (noOfEqual == 0)
		{
			// find total
			total = 0;
			for (j = 0; j < orgEqClassList->noOfElt; j++)
			{
				genEqID = orgEqClassList->elt[j];

				total += genEqTupleList[genEqID]->noOfMember;

				contributeCount[j] = genEqTupleList[genEqID]->noOfMember;
			}
		}
		else
		{
			//  find total
			total = 0;
			allRemain = orgEqTupleList[i]->noOfMember;
			allRemain -= noOfEqual;
			for (j = 0; j < orgEqClassList->noOfElt; j++)
			{
				genEqID = orgEqClassList->elt[j];

				if (j == equalIndex)
				{
					total += genEqTupleList[genEqID]->noOfMember;

					contributeCount[j] = genEqTupleList[genEqID]->noOfMember;

					
				}
				else
				{
					// assume we need allTotal
					if (allRemain > 0)
					{
						if (allRemain >= genEqTupleList[genEqID]->noOfMember)
						{
							increment = genEqTupleList[genEqID]->noOfMember;
						}
						else
						{
							increment = allRemain;
						}


						total += increment;

						contributeCount[j] = increment;

						allRemain -= increment;
					}
				}
			}
		}

		for (j = 0; j < orgEqClassList->noOfElt; j++)
		{
			genEqID = orgEqClassList->elt[j];

			relativeIndex = findRelativeIndexInGenEqClassList(allGenEqClassList[genEqID], i);


			firstTerm = contributeCount[j]/((double)total);
			if (aOutput[genEqID]->probability == NULL)
			{
				secondTerm = -2;
			}
			else
			{
				secondTerm = aOutput[genEqID]->probability[relativeIndex];
			}
			if (secondTerm == -2)
			{
				// i.e. use the orignal
				secondTerm = genEqTupleList[genEqID]->noOfSen/((double)genEqTupleList[genEqID]->noOfMember);
			}

			if (secondTerm == -1)
			{
				returnValue[i] = -1;
				break;
			}
			else
			{
				returnValue[i] += firstTerm*secondTerm;
			}
		}
		free(contributeCount);
	}

	return returnValue;
}


	
	

void calCred_analysis(int noOfSenValueInSenAttr, int d, equivalenceClass *orgEqClass, equivalenceClass *genEqClass, int noOfQID, double *probList, mySet **allOrgEqClassList, mySet **allGenEqClassList)
{
	FILE *filePtr;
	char *filename = "analysis.txt";

	int i, j, k, l;
	equivalenceTuple *orgEqTuple;
	equivalenceTuple *genEqTuple;
	equivalenceTuple *orgEqTuple2;

	mySet *orgEqClassList;
	mySet *genEqClassList;

	int genEqID;
	int orgEqID2;

	int noOfSen;

	int totalNoOfTupleViolate;
	

	filePtr = (FILE *) fopen(filename, "w");

	totalNoOfTupleViolate = 0;
	for (i = 0; i < orgEqClass->noOfEqClass; i++)
	{
		orgEqTuple = orgEqClass->eqClass[i];

		if (probList[i] > 1.0/d)
		{
			totalNoOfTupleViolate += orgEqTuple->noOfMember;
		}
	}
	fprintf(filePtr, "No of tuples violated: %d\n", totalNoOfTupleViolate);
	printf("No of tuples violated: %d\n", totalNoOfTupleViolate);

	for (i = 0; i < orgEqClass->noOfEqClass; i++)
	{

		if (probList[i] == 1.0)
		{
			fprintf(filePtr, " @@@@@@@@@@@@@@@ 100%% Credibility @@@@@@@@\n");
		}
	

		if (probList[i] > 1.0/d)
		{
			orgEqTuple = orgEqClass->eqClass[i];

			fprintf(filePtr, "Equivalence Class %d (with prob %.6f)\n", i, probList[i]);
			fprintf(filePtr, "---------------------------------------------------------\n");
			fprintf(filePtr, "  no of member     : %d\n", orgEqTuple->noOfMember);
			fprintf(filePtr, "  no of ungenMember: %d\n", orgEqTuple->noOfUnGenMember);
			fprintf(filePtr, "  original content : ");

			for (j = 0; j < noOfQID; j++)
			{
				fprintf(filePtr, "(%d %d) ", orgEqTuple->content[j].level, orgEqTuple->content[j].value);
			}
			fprintf(filePtr, "\n");
			fprintf(filePtr, "  sensitve content : ");
			for (j = 0; j < noOfSenValueInSenAttr; j++)
			{
				noOfSen = orgEqTuple->noOfEachSen[j];
				if (noOfSen != 0)
				{
					fprintf(filePtr, "(%d : %d times) ", j, noOfSen);
				}
			}
			fprintf(filePtr, "\n");

			orgEqClassList = allOrgEqClassList[i];

			//fprintf(filePtr, "  generalized value : ");
			for (k = 0; k < orgEqClassList->noOfElt ; k++)
			{
				genEqID = orgEqClassList->elt[k];

				genEqTuple = genEqClass->eqClass[genEqID];

				fprintf(filePtr, "    %d. no of member     : %d\n", k, genEqTuple->noOfMember);
				//fprintf(filePtr, "        no of ungenMember: %d\n", orgEqTuple->noOfUnGenMember);
				fprintf(filePtr, "       generalized content: ", k);
				for (j = 0; j < noOfQID; j++)
				{
					fprintf(filePtr, "(%d %d) ", genEqTuple->content[j].level, genEqTuple->content[j].value);
				}
				fprintf(filePtr, "\n");
				fprintf(filePtr, "       genearlized sensitve content : ");
				for (j = 0; j < noOfSenValueInSenAttr; j++)
				{
					noOfSen = genEqTuple->noOfEachSen[j];
					if (noOfSen != 0)
					{
						fprintf(filePtr, "(%d : %d times) ", j, noOfSen);
					}
				}
				fprintf(filePtr, "\n");

				//
				genEqClassList = allGenEqClassList[genEqID];

				for (l = 0; l < genEqClassList->noOfElt ; l++)
				{
					orgEqID2 = genEqClassList->elt[l];

					orgEqTuple2 = orgEqClass->eqClass[orgEqID2];

					fprintf(filePtr, "            %d. no of member     : %d\n", l, orgEqTuple2->noOfMember);
					fprintf(filePtr, "               no of ungenMember: %d\n", orgEqTuple2->noOfUnGenMember);
					fprintf(filePtr, "               matched ungeneralized value: ");
					for (j = 0; j < noOfQID; j++)
					{
						fprintf(filePtr, "(%d %d) ", orgEqTuple2->content[j].level, orgEqTuple2->content[j].value);
					}
					fprintf(filePtr, "\n");
					fprintf(filePtr, "               matched sensitve content   : ");
					for (j = 0; j < noOfSenValueInSenAttr; j++)
					{
						noOfSen = orgEqTuple2->noOfEachSen[j];
						if (noOfSen != 0)
						{
							fprintf(filePtr, "(%d : %d times) ", j, noOfSen);
						}
					}
					

					fprintf(filePtr, "\n");
				}
			}
		}
	}

	fclose(filePtr);
}
double *calculateCredibility(int noOfSenValueInSenAttr, equivalenceClass *orgEqClass, equivalenceClass *genEqClass, int noOfQID, int d, generalizedAllTable *genAllTable)
{
	vInputOutput **aOutput;
	double *probList;

	mySet **allOrgEqClassList;
	mySet **allGenEqClassList;

	int i;

	printf("  Finding orgEqClass matching with GenEqClass...\n");
	findOrgEqClassMatchGenEqClass(noOfQID, genAllTable, orgEqClass, genEqClass, &allOrgEqClassList, &allGenEqClassList);

	printf("  Calculating V...\n");
	aOutput = calculateFunctionVForGenEqClass(d, genEqClass, orgEqClass, allGenEqClassList);
 
	printf("  Calculating credibility for each class...\n");
	probList = calculateCredibilityFromOrgEqClass(noOfQID, orgEqClass, genEqClass, allOrgEqClassList, allGenEqClassList, aOutput);  

	// analysis
	calCred_analysis(noOfSenValueInSenAttr, d, orgEqClass, genEqClass, noOfQID, probList, allOrgEqClassList, allGenEqClassList);

	// free
	for (i = 0; i < genEqClass->noOfEqClass; i++)
	{
		vInputOutput_free(aOutput[i]);
	}
	free(aOutput);


	return probList;

}


void calCredMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable)
{
	FILE *debugFilePtr;

	int isAlphaK;

	int kAnonymity;
	int noOfQID;

	summary *synopsis;
	equivalenceClass *proEqClass;
	equivalenceClass *finalEqClass;
	//mechAllGroup *finalMechAllGroup;

	int noOfValueInSenAttr;

	int noOfSlot;
	float delta;

	float maxValue;

	//double avgRelError;

	int i;
	double *probList;

	//allCondition *aAllCondition;

	//twoTable *finalTable;
	//FILE *filePtr;

	int senStartNo, senEndNo;

	//int nonSenStartNo;
	//int nonSenEndNo;

	//double infoLoss, distortion;
	//int noOfSenChange;

	dimensionSetSet *sensitiveSetSet;
	//dimensionSet *sensitiveSet;

	char *avgRelErrorFilename = "error.txt";
	char *timeFilename = "time.txt";

	int queryNoOfDim = conf->queryNoOfDim;
	double s = conf->s;
	int noOfCondition = conf->noOfCondition;

	int noOfViolation;

	double totalCred;

	int noOfSenValueInSenAttr;

#ifndef _WIN32
	FILE *filePtr;
	float  userTime, sysTime;
	float userTime_topDown, sysTime_topDown;
	struct rusage myTime1, myTime2, myTime_topDownEnd;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	noOfQID = conf->noOfDim-conf->noOfSenAttr;
	kAnonymity = conf->K;

	if (conf->noOfTuple > 200)
	{
		noOfSlot = ((conf->noOfTuple*conf->noOfTuple)/200)-1;
	}
	else
	{
		noOfSlot = 5;
	}
	delta = 5.0f;

	maxValue = (float) (conf->noOfDim*2)*conf->noOfTuple/conf->K;

	debugFilePtr = (FILE *) fopen("debug.txt", "w");
	g_debugFilePtr = debugFilePtr;

	//dimensionSetSet *readSensitiveSet(configure *conf)
	sensitiveSetSet = readSensitiveSet(conf);

	printf("Random Algorithm....\n");

	// preprocessing
	//printf("Preprocessing....\n");
	//prepProcessDataSet(dataSet, conf->K, genAllTable);

	// create summary
	printf("Creating Summary....\n");
	synopsis = createSummary(dataSet);

	// printing
	//fprintf(debugFilePtr, "############## Summary ##################\n");
	//printf("############## Summary ##################\n");
	//printSummary(debugFilePtr, synopsis, conf->noOfDim);

	// check whether it is alphaK
	//isAlphaK = isAlphaKAnonymity(dataSet, synopsis, conf);
	//isAlphaK = 1;

	senStartNo = conf->senStartNo;
	senEndNo = conf->senEndNo;

	// generate equivalence class from the data
	printf("Generating eq. class from Data....\n");
	proEqClass = generateEquivalenceClass(dataSet, synopsis, conf); 
	noOfValueInSenAttr = dataSet->dimSize[noOfQID];
	createSenValueInEqClass(proEqClass, dataSet, noOfValueInSenAttr);
	isAlphaK = isMech(proEqClass, conf, noOfValueInSenAttr);

	// 
	if (isAlphaK == 0)
	{
		printf("This data set cannot satisfy the alpha K anonymity!\n");
		exit(0);
	}
	else
	{
		// continue

		// enforce alpha = 1/d
		conf->alpha = 1.0/conf->d;
		conf->K = 1;

		printf("Running top down approach ....\n");

		if (conf->alg == 11)
		{
			finalEqClass = fullSpace_KAlphaAnonymity(dataSet, conf, genAllTable, debugFilePtr);
		}
		else
		{
			//equivalenceClass *topDownAlpha_KAlphaAnonymity(data *dataSet, configure *conf, generalizedAllTable *genAllTable, FILE *g_debugFilePtr)
			finalEqClass = topDownAlpha_KAlphaAnonymity(dataSet, conf, genAllTable, debugFilePtr);
		}

		createSenValueInEqClass(finalEqClass, dataSet, noOfValueInSenAttr);

		// printing
		fprintf(debugFilePtr, "############## proEqClass ##################\n");
		printf("############## proEqClass ##################\n");
		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
		printf("############## finalEqClass ##################\n");
		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

#ifndef _WIN32

	getrusage(RUSAGE_SELF, &myTime_topDownEnd);	

	userTime =
     		((float) (myTime_topDownEnd.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime_topDownEnd.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
	sysTime =
       		((float) (myTime_topDownEnd.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime_topDownEnd.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;


	userTime_topDown = userTime;
	sysTime_topDown = sysTime;
#endif

		printf("Calculating credibility ....\n");
		noOfSenValueInSenAttr = dataSet->dimSize[noOfQID];
		probList = calculateCredibility(noOfSenValueInSenAttr, proEqClass, finalEqClass, noOfQID, conf->d, genAllTable);

		// calculate no. of violation
		noOfViolation = 0;
		totalCred = 0;
		for (i = 0; i < proEqClass->noOfEqClass; i++)
		{
			if (probList[i] > 1.0/conf->d)
			{
				noOfViolation++;
				totalCred += probList[i];
			}
		}

		fprintf(g_debugFilePtr, "%.10f\n", noOfViolation/((double) proEqClass->noOfEqClass));
		fprintf(g_debugFilePtr, "%.10f\n", totalCred/noOfViolation);
		fprintf(g_debugFilePtr, "%d\n", noOfViolation);
		fprintf(g_debugFilePtr, "%d\n", proEqClass->noOfEqClass);
		printf("prop of violations   : %.6f\n", noOfViolation/((double) proEqClass->noOfEqClass));
		printf("avg. credibility     : %.6f\n", totalCred/noOfViolation);
		printf("no of violations     : %d\n", noOfViolation);
		printf("total no. of eq class: %d\n", proEqClass->noOfEqClass);
		for (i = 0; i < proEqClass->noOfEqClass; i++)
		{
			fprintf(g_debugFilePtr, "%.6f\n", probList[i]);
		}

	}

#ifndef _WIN32
	getrusage(RUSAGE_SELF, &myTime2);	
#endif

#ifndef _WIN32
	userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
	sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

	printf("User time : %f seconds\n",userTime);
	printf("System time : %f seconds\n\n",sysTime);

	fprintf(debugFilePtr, "Execution Time\n");
	fprintf(debugFilePtr, "--------------\n");
	fprintf(debugFilePtr, "User time : %f seconds\n",userTime);
    fprintf(debugFilePtr, "System time : %f seconds\n\n",sysTime);


	filePtr = (FILE *) fopen(timeFilename, "w");
	fprintf(filePtr, "%.6f\n",userTime);
    fprintf(filePtr, "%.6f\n\n",sysTime);
	fprintf(filePtr, "%.6f\n",userTime_topDown);
    fprintf(filePtr, "%.6f\n\n",sysTime_topDown);
	fclose(filePtr);
#endif

	fclose(debugFilePtr);
}

