
#ifndef CALV_H
#define CALV_H

#include <math.h>
#include "readData.h"
#include "generalization.h"
#include "readData.h"
#include "set.h"
#include "mechDistortion.h"
#include "equivalence.h"
#include "possWorld.h"
#include "signature.h"
//#include "newton.h"
#include "injector.h"

struct violateTuple_s
{
	int id;

	int noOfAttr;

	int *dimNo;
	dimension *content;

	int senValue;

	float prob;

	int eqID;
};

typedef struct violateTuple_s violateTuple;

struct violateGroup_s
{
	int noOfTuple;

	violateTuple **tupleList;
};

typedef struct violateGroup_s violateGroup;

struct violateStatistics_s
{
	int max_noOfViolateTuple;
	float avg_noOfViolateTuple;
	int sum_noOfViolateTuple;
	int min_noOfViolateTuple;

	float max_avgViolateProb;
	float avg_avgViolateProb;
	float sum_avgViolateProb;
	float min_avgViolateProb;

	int count;

};

typedef struct violateStatistics_s violateStatistics;


float *g_prob;

int calViolation_calculateSampleSize(float error, float sigma);

extern float *newton_main(term **termList, int noOfTerm, float *initVector);


void calViolationMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable);

void calculateViolation(FILE *filePtr, configure *config, data *aData, int sampleThreshold, float violateThreshold, equivalenceClass *eqClass);

#endif
