
#include "config.h"

int MAXSTR = 2048;

configure *new_config()
{
	configure *returnValue;

	returnValue = (configure *) malloc(sizeof(configure));

	returnValue->dataFilename = (char *) malloc(sizeof(char)*MAXSTR);
	returnValue->dimFilename = (char *) malloc(sizeof(char)*MAXSTR);
	returnValue->hierarchyFilename = (char *) malloc(sizeof(char)*MAXSTR);
	returnValue->genDataFilename = (char *) malloc(sizeof(char)*MAXSTR);
	returnValue->sensitiveSetFilename = (char *) malloc(sizeof(char)*MAXSTR);

	return returnValue;
}

configure *readConfig(char *filename)
{
	configure *returnValue;

	FILE *filePtr;

	float aNo;
	int i;

	filePtr = (FILE *) fopen(filename, "r");

	returnValue = new_config();

	// K
	// no of tuple
	// no of dims
	// data file name
	// dim file name
	// alpha
	

	fscanf(filePtr, "%d\n", &(returnValue->K));
	fscanf(filePtr, "%d\n", &(returnValue->noOfTuple));
	fscanf(filePtr, "%d\n", &(returnValue->noOfDim));
	fscanf(filePtr, "%s\n", returnValue->dataFilename);
	fscanf(filePtr, "%s\n", returnValue->dimFilename);
	fscanf(filePtr, "%s\n", returnValue->hierarchyFilename);
	fscanf(filePtr, "%s\n", returnValue->genDataFilename);
	fscanf(filePtr, "%f\n", &aNo);

	returnValue->alpha = aNo;

	fscanf(filePtr, "%d\n", &(returnValue->noOfSenAttr));
	returnValue->senAttrNo = (int *) malloc(sizeof(int)*returnValue->noOfSenAttr);
	memset(returnValue->senAttrNo, 0, sizeof(int)*returnValue->noOfSenAttr);
	for (i = 0; i < returnValue->noOfSenAttr; i++)
	{
		fscanf(filePtr, "%d\n", &(returnValue->senAttrNo[i])); 
		fscanf(filePtr, "%d\n", &(returnValue->senStartNo));
		fscanf(filePtr, "%d\n", &(returnValue->senEndNo));
	}

	fscanf(filePtr, "\n");

	fscanf(filePtr, "%d\n", &(returnValue->d));
	fscanf(filePtr, "%s\n", returnValue->sensitiveSetFilename);

	fscanf(filePtr, "%f\n", &aNo);
	
	returnValue->s = aNo;

	fscanf(filePtr, "%d\n", &(returnValue->noOfCondition));
	fscanf(filePtr, "%d\n", &(returnValue->queryNoOfDim));
	fscanf(filePtr, "%f\n", &(aNo));
	returnValue->error = aNo;
	fscanf(filePtr, "%f\n", &(aNo));
	returnValue->sigma = aNo;
	fscanf(filePtr, "%f\n", &(aNo));
	returnValue->minConf = aNo;
	fscanf(filePtr, "%f\n", &(aNo));
	returnValue->minExp = aNo;
	fscanf(filePtr, "%d\n", &(returnValue->alg));

	// temp: set to 0.2
	returnValue->tThreshold = 0.2;

	fclose(filePtr);

	return returnValue;
}
