
#include "equivalence.h"
#include "kDist.h"

#ifndef _WIN32
#include <sys/resource.h>
#include <sys/times.h>
#include <unistd.h>
#endif

int isFlag;


equivalenceClass *new_equivalenceClass()
{
	equivalenceClass *returnValue;

	returnValue = (equivalenceClass *) malloc(sizeof(equivalenceClass));

	returnValue->noOfEqClass = 0;
	returnValue->eqClass = NULL;

	return returnValue;
}

equivalenceTuple *equivalenceTuple_new()
{
	equivalenceTuple *returnValue;

	returnValue = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	memset(returnValue, 0, sizeof(equivalenceTuple));

	return returnValue;
}

void printEquivalenceTuple(FILE *filePtr, equivalenceTuple *eqOne, int noOfDim)
{
	int j;
	int noOfSenValue;

		fprintf(filePtr, "           Value         : ");
		printf("           Value         : ");
		
		if (eqOne->content != NULL)
		{
			for (j = 0; j < noOfDim; j++)
			{
				fprintf(filePtr, "(%d %d) ", eqOne->content[j].level, eqOne->content[j].value);
				printf("(%d %d) ", eqOne->content[j].level, eqOne->content[j].value);
			}
		}
		fprintf(filePtr, "\n");
		printf("\n");

		fprintf(filePtr, "           id            : %d\n", eqOne->id);
		printf("           id            : %d\n", eqOne->id);

		fprintf(filePtr, "           No. of Members: %d\n", eqOne->noOfMember);
		fprintf(filePtr, "           No. of Sens   : %d\n", eqOne->noOfSen);
		printf("           No. of Members: %d\n", eqOne->noOfMember);
		printf("           No. of Sens   : %d\n", eqOne->noOfSen);

		fprintf(filePtr, "           Members : \n");
		fprintf(filePtr, "              ");
		printf("           Members : \n");
		printf("              ");
		for (j = 0; j < eqOne->noOfMember; j++)
		{
			fprintf(filePtr, "%d ", eqOne->member[j]);
			printf("%d ", eqOne->member[j]);
		}
		fprintf(filePtr, "\n");
		printf("\n");

		if (eqOne->isSen != NULL)
		{
			fprintf(filePtr, "           Sens : \n");
			fprintf(filePtr, "              ");
			printf("           Sens : \n");
			printf("              ");
			for (j = 0; j < eqOne->noOfMember; j++)
			{
				fprintf(filePtr, "%d ", eqOne->isSen[j]);
				printf("%d ", eqOne->isSen[j]);
			}
			fprintf(filePtr, "\n");
			fprintf(filePtr, "\n");
			printf("\n");
			printf("\n");
		}

		if (eqOne->noOfEachSen != NULL)
		{
			//configure *g_config;
			//data *g_data;
			
			noOfSenValue = g_data->dimSize[g_config->noOfDim-1];

			fprintf(filePtr, "           noOfEachSen : \n");
			fprintf(filePtr, "              ");
			printf("           noOfEachSen : \n");
			printf("              ");
			for (j = 0; j < noOfSenValue; j++)
			{
				fprintf(filePtr, "%d ", eqOne->noOfEachSen[j]);
				printf("%d ", eqOne->noOfEachSen[j]);
			}
			fprintf(filePtr, "\n");
			fprintf(filePtr, "\n");
			printf("\n");
			printf("\n");
		}

		if (eqOne->noOfEachSenIndex != NULL)
		{
			fprintf(filePtr, "           noOfEachSenIndex : \n");
			fprintf(filePtr, "              ");
			printf("           noOfEachSenIndex : \n");
			printf("              ");
			for (j = 0; j < 2; j++)
			{
				fprintf(filePtr, "%d ", eqOne->noOfEachSenIndex[j]);
				printf("%d ", eqOne->noOfEachSenIndex[j]);
			}
			fprintf(filePtr, "\n");
			fprintf(filePtr, "\n");
			printf("\n");
			printf("\n");
		}

}

void printEquivalenceClass(FILE *filePtr, equivalenceClass *eqClass, int noOfDim)
{
	int i; //, j;

	equivalenceTuple **eqTuple;
	equivalenceTuple *eqOne;

	fprintf(filePtr, "---------------------------------------------\n");
	fprintf(filePtr, "No. of Eq. Classes: %d\n", eqClass->noOfEqClass);
	printf("---------------------------------------------\n");
	printf("No. of Eq. Classes: %d\n", eqClass->noOfEqClass);

	eqTuple = eqClass->eqClass;
	

	for (i = 0; i < eqClass->noOfEqClass; i++)
	{

		//eqOne = &(eqTuple[i]);
		eqOne = eqTuple[i];

		fprintf(filePtr, "      ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
		fprintf(filePtr, "      Eq. Class %d. \n", i);
		printf("      ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
		printf("      Eq. Class %d. \n", i);
		

		printEquivalenceTuple(filePtr, eqOne, noOfDim);
	}

}

int temp_noOfSen;
int temp_noOfMem;
void checkEachEquivalenceClass(FILE *filePtr, equivalenceClass *eqClass, int noOfDim)
{
	int i;

	float aNo = 0.8f;

	equivalenceTuple **eqTuple;
	equivalenceTuple *eqOne;

	eqTuple = eqClass->eqClass;

	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		//eqOne = &(eqTuple[i]);
		eqOne = eqTuple[i];

		temp_noOfSen += eqOne->noOfSen;
		temp_noOfMem += eqOne->noOfMember;

		if ((eqOne->noOfSen == (int) (eqOne->noOfMember*aNo)) || (eqOne->noOfSen == (int) (eqOne->noOfMember*aNo) + 1))
		{
			// no problem
		}
		else
		{
			// 
//			fprintf(filePtr, "@@@@@@@@@@@@@@@@ Problem (No. %i): NoOfMember:%d  NoOfSen:%d\n", i, eqOne->noOfMember, eqOne->noOfSen);
		}
	}
}

int isAlphaKAnonymity_EquivalenceClass(equivalenceTuple *eqOne, configure *conf)
{
	if ((eqOne->noOfMember >= conf->K) && (eqOne->noOfSen <= ceiling(eqOne->noOfMember*conf->alpha)))
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

void insertEqTupleIntoEqClass(equivalenceClass *eqClass, equivalenceTuple *eqTuple)
{
	int noOfEqClass;

	equivalenceTuple **list;
	equivalenceTuple *eqTupleNew;

	noOfEqClass = eqClass->noOfEqClass;

	list = eqClass->eqClass;

	if (noOfEqClass > 0)
	{
		list = (equivalenceTuple **) realloc(list, sizeof(equivalenceTuple *)*(noOfEqClass+1));
	}
	else
	{
		list = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *));
	}

	eqTupleNew = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	memcpy(eqTupleNew, eqTuple, sizeof(equivalenceTuple));
	list[noOfEqClass] = eqTupleNew;
	//memcpy(&(list[noOfEqClass]), eqTupleNew, sizeof(equivalenceTuple));
	noOfEqClass++;

	eqClass->noOfEqClass = noOfEqClass;
	eqClass->eqClass = list;
}


void insertEqTupleIntoEqClassWithoutClone(equivalenceClass *eqClass, equivalenceTuple *eqTuple)
{
	int noOfEqClass;

	equivalenceTuple **list;

	noOfEqClass = eqClass->noOfEqClass;

	list = eqClass->eqClass;

	if (noOfEqClass > 0)
	{
		list = (equivalenceTuple **) realloc(list, sizeof(equivalenceTuple *)*(noOfEqClass+1));
	}
	else
	{
		list = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *));
	}

	list[noOfEqClass] = eqTuple;
	noOfEqClass++;

	eqClass->noOfEqClass = noOfEqClass;
	eqClass->eqClass = list;
}

void removeEqTupleFromEqClass(equivalenceClass *eqClass, int index)
{
	int noOfEqClass;

	equivalenceTuple **newList;
	equivalenceTuple **oldList;

	noOfEqClass = eqClass->noOfEqClass;

	oldList = eqClass->eqClass;

	newList = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *)*(noOfEqClass-1));

	if (index != 0)
	{
		memcpy(newList, oldList, sizeof(equivalenceTuple *)*index);
	}

	if (index != noOfEqClass-1)
	{
		memcpy(&(newList[index]), &(oldList[index+1]), sizeof(equivalenceTuple *)*(noOfEqClass-index-1));
	}

	//free(oldList[index]->content);
	//free(oldList[index]->member);
	//free(oldList[index]->isSen);
	//free(oldList[index]);

	free(oldList);

	eqClass->eqClass = newList;
	eqClass->noOfEqClass--;
}

void removeEquivalenceClassWithZeroMember(equivalenceClass *eqClass)
{
	int i;

	equivalenceTuple **eqTuple;
	equivalenceTuple *eqOne;
	int noOfEqClass;

	eqTuple = eqClass->eqClass;

	noOfEqClass = eqClass->noOfEqClass;

	for (i = noOfEqClass-1; i >= 0; i--)
	{
		//eqOne = &(eqTuple[i]);
		eqOne = eqTuple[i];

		//if (i == 24238)
		//{
		//	printf("");
		//}
		//if (i == 24237)
		//{
		//	printf("");
		//}
		if (eqOne->noOfMember == 0)
		{
			removeEqTupleFromEqClass(eqClass, i);
			eqTuple = eqClass->eqClass;
		}
	}
}

equivalenceClass *generateEquivalenceClass(data *dataSet, summary *synopsis, configure *conf)
{
	equivalenceClass *returnValue;

	int noOfEqClass;

	int *eqIndex;
	int i, j, k;
	int prevValue;

	int noOfDim;
	int *dimNo;

	int *combineList;

	int noOfMember;
	int *member;

	group *grouping;

	int noOfSen;

	equivalenceTuple **eqClass;

	int senAttrNo;

	//int SEN_VALUE = 1;

	int *isSen;

	int isThisSen;
	

	returnValue = (equivalenceClass *) malloc(sizeof(equivalenceClass));

	// dim (temp)
	noOfDim = dataSet->noOfDim-1;
	dimNo = (int *) malloc(sizeof(int)*noOfDim);
	for (i = 0; i < noOfDim; i++)
	{
		dimNo[i] = i;
	}


	// create list from summary
	combineList = createListFromSummary(dataSet, synopsis, noOfDim, dimNo);

	// no need to sort (as the summary has already sorted)

	// count no. of eq. classes
	prevValue = -1;
	noOfEqClass = 0;
	for (i = 0; i < synopsis->noOfGroup; i++)
	{
		if (prevValue != combineList[i])
		{
			noOfEqClass++;
			prevValue = combineList[i];
		}
	}

	returnValue->noOfEqClass = noOfEqClass;
	eqClass = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *)*noOfEqClass);

	eqIndex = (int *) malloc(sizeof(int)*(noOfEqClass+1));
	memset(eqIndex, 0, sizeof(int)*(noOfEqClass+1));

	// find the index
	prevValue = -1;
	noOfEqClass = 0;
	for (i = 0; i < synopsis->noOfGroup; i++)
	{
		if (prevValue != combineList[i])
		{
			eqIndex[noOfEqClass] = i;

			noOfEqClass++;
			prevValue = combineList[i];
		}
	}
	eqIndex[noOfEqClass] = synopsis->noOfGroup;

	// Assume only one sensitve value
	grouping = synopsis->grouping;
	senAttrNo = conf->senAttrNo[0];
	//SEN_VALUE = 1;
	for (i = 0; i < noOfEqClass; i++)
	{
		eqClass[i] = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
		memset(eqClass[i], 0, sizeof(equivalenceTuple));

		noOfMember = 0;
		noOfSen = 0;
		for (j = eqIndex[i]; j < eqIndex[i+1]; j++)
		{
			noOfMember += grouping[j].noOfMember;

			isThisSen = 0;
			for (k = conf->senStartNo; k <= conf->senEndNo ; k++)
			{
				if (grouping[j].content[senAttrNo].value == k)
				{
					isThisSen = 1;
					break;
				}
			}

			//if (grouping[j].content[senAttrNo].value == SEN_VALUE)
			if (isThisSen == 1)
			{
				noOfSen += grouping[j].noOfMember;
			}
		}

		eqClass[i]->content = (dimension *) malloc(sizeof(dimension)*conf->noOfDim);
		memcpy(eqClass[i]->content, grouping[eqIndex[i]].content, sizeof(dimension)*conf->noOfDim);
		// although we copied the sensitve attr (but we will not use it)



		eqClass[i]->noOfMember = noOfMember;
		eqClass[i]->noOfSen = noOfSen;

		// newly added
		eqClass[i]->id = i;
	}
	
	//
	for (i = 0; i < noOfEqClass; i++)
	{
		noOfMember = eqClass[i]->noOfMember;
		member = (int *) malloc(sizeof(int)*noOfMember);
		isSen = (int *) malloc(sizeof(int)*noOfMember);
		memset(isSen, 0, sizeof(int)*noOfMember);

		noOfMember = 0;
		for (j = eqIndex[i]; j < eqIndex[i+1]; j++)
		{
			memcpy(&(member[noOfMember]), grouping[j].member, sizeof(int)*grouping[j].noOfMember);

			isThisSen = 0;
			for (k = conf->senStartNo; k <= conf->senEndNo ; k++)
			{
				if (grouping[j].content[senAttrNo].value == k)
				{
					isThisSen = 1;
					break;
				}
			}

			//if (grouping[j].content[senAttrNo].value == SEN_VALUE)
			if (isThisSen == 1)
			{
				for (k = 0; k < grouping[j].noOfMember; k++)
				{
					isSen[k+noOfMember] = 1;
				}
			}

			noOfMember += grouping[j].noOfMember;
		}

		eqClass[i]->member = member;
		eqClass[i]->isSen = isSen;

	}

	returnValue->eqClass = eqClass;

	
	free(dimNo);
	free(combineList);

	return returnValue;
}

int ceiling(double no)
{
	if (no - ((int)no) == 0)
	{
		return (int)no;
	}
	else
	{
		return ((int)no)+1;
	}
}

int eqClass_isPotentialTrunk(equivalenceTuple *eqTuple, configure *conf)
{
	int returnValue;
	int K;

	double alpha;

	K = conf->K;
	alpha = conf->alpha;

	
	returnValue = 0;

	// stub and trunk requirement
	//if (eqTuple->noOfMember >= 2*K-1)
	if (eqTuple->noOfMember >= K)
	{
		// 
		//if (eqTuple->noOfSen <= alpha*eqTuple->noOfMember)
		//if (eqTuple->noOfSen >= ceiling(alpha*K)) //&& eqTuple->noOfSen <= alpha*(eqTuple->noOfMember-(K-1))))
		//if ((eqTuple->noOfSen >= (int) (alpha*K)) && (eqTuple->noOfSen <= ceiling(alpha*eqTuple->noOfMember)))
		if ((eqTuple->noOfSen >= ceiling(alpha*K)) && (eqTuple->noOfSen <= ceiling(alpha*eqTuple->noOfMember)))
		{
			returnValue = 1;
		}
	}
	

	return returnValue;
}


int *getListEqClass_PotentialTrunk(equivalenceClass *eqClass, configure *conf, int *noOfList)
{
	int *returnValue;
	int i;

	int isPotential;

	int no;

	equivalenceTuple **eClass;

	eClass = eqClass->eqClass;

	no = 0;
	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		//isPotential = eqClass_isPotentialTrunk(&(eClass[i]), conf);
		isPotential = eqClass_isPotentialTrunk(eClass[i], conf);

		if (isPotential == 1)
		{
			no++;
		}
	}

	(*noOfList) = no;
	returnValue = (int *) malloc(sizeof(int)*no);

	no = 0;
	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		//isPotential = eqClass_isPotentialTrunk(&(eClass[i]), conf);
		isPotential = eqClass_isPotentialTrunk(eClass[i], conf);

		if (isPotential == 1)
		{
			returnValue[no] = i;

			no++;
		}
	}

	return returnValue;
	
}

int findMin(int no1, int no2)
{
	if (no1 > no2)
	{
		return no2;
	}
	else
	{
		return no1;
	}
}

equivalenceTuple *splitEqClass_LastOne(equivalenceTuple *eqTuple, configure *conf)
{
	equivalenceTuple *returnValue;

	returnValue = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	//returnValue->noOfMember = findMin(ceiling(eqTuple->noOfSen/conf->alpha), eqTuple->noOfMember);
	returnValue->noOfSen = eqTuple->noOfSen;

	returnValue->noOfMember = eqTuple->noOfMember;

	returnValue->content = (dimension *) malloc(sizeof(dimension)*conf->noOfDim);
	memcpy(returnValue->content, eqTuple->content, sizeof(dimension)*conf->noOfDim);

	returnValue->isSen = (int *) malloc(sizeof(int)*returnValue->noOfMember);
	returnValue->member = (int *) malloc(sizeof(int)*returnValue->noOfMember);
	memcpy(returnValue->isSen, eqTuple->isSen, sizeof(int)*returnValue->noOfMember);
	memcpy(returnValue->member, eqTuple->member, sizeof(int)*returnValue->noOfMember);

	eqTuple->noOfMember = 0;
	// free for isSen and Member for eqTuple .
	// ...

	return returnValue;
}



equivalenceTuple *splitEqClass_Trunk(equivalenceTuple *eqTuple, configure *conf)
{
	int i;
	equivalenceTuple *returnValue;

	int *isRemove;

	int countMem, countSen;

	int *newMember;
	int *newIsSen;

	int count;

	int minBound;

	returnValue = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	//returnValue->noOfMember = findMin(ceiling(eqTuple->noOfSen/conf->alpha), eqTuple->noOfMember);
	returnValue->noOfSen = eqTuple->noOfSen;

	minBound = (int) ((eqTuple->noOfSen-1)/conf->alpha);
	while (ceiling(minBound*conf->alpha) < returnValue->noOfSen)
	{
		minBound++;
	}
	returnValue->noOfMember = findMin(minBound, eqTuple->noOfMember);

	returnValue->content = (dimension *) malloc(sizeof(dimension)*conf->noOfDim);
	memcpy(returnValue->content, eqTuple->content, sizeof(dimension)*conf->noOfDim);

	returnValue->isSen = (int *) malloc(sizeof(int)*returnValue->noOfMember);
	returnValue->member = (int *) malloc(sizeof(int)*returnValue->noOfMember);
	memset(returnValue->isSen, 0, sizeof(int)*returnValue->noOfMember);

	isRemove = (int *) malloc(sizeof(int)*eqTuple->noOfMember);
	memset(isRemove, 0, sizeof(int)*eqTuple->noOfMember);
	countMem = 0;
	countSen = 0;
	// do sensitve first
	for (i = 0; i < eqTuple->noOfMember; i++)
	{
		if (eqTuple->isSen[i] == 1)
		{
			returnValue->isSen[countMem] = 1;
			returnValue->member[countMem] = eqTuple->member[i];
			isRemove[i] = 1;
			countMem++;
		}
		else
		{
			//
		}
	}

	// do non-sensitve 
	if (countMem < returnValue->noOfMember)
	{
		for (i = 0; i < eqTuple->noOfMember; i++)
		{
			if (eqTuple->isSen[i] == 1)
			{
				
			}
			else
			{
				returnValue->isSen[countMem] = 0;
				returnValue->member[countMem] = eqTuple->member[i];
				isRemove[i] = 1;
				countMem++;
			}
			

			if (countMem >= returnValue->noOfMember)
			{
				break;
			}
		}
	}



	// maintain the eq class (oringal)
	if (eqTuple->noOfMember - returnValue->noOfMember == 0)
	{
		newMember = NULL;
		newIsSen = NULL;
	}
	else
	{
		newIsSen = (int *) malloc(sizeof(int)*(eqTuple->noOfMember - returnValue->noOfMember));
		newMember = (int *) malloc(sizeof(int)*(eqTuple->noOfMember - returnValue->noOfMember));
		count = 0;
		for (i = 0; i < eqTuple->noOfMember; i++)
		{
			if (isRemove[i] == 0)
			{
				newMember[count] = eqTuple->member[i];
				newIsSen[count] = eqTuple->isSen[i];
				count++;
			}
		}
	}

//if (isFlag == 1)
//printf("   ~~~~~~ haha9..\n");
//if (isFlag == 1)
//{
//	printf("      member:%p\n", eqTuple->member);
//	printf("             ");
//	for (i = 0; i < eqTuple->noOfMember; i++)
//	{
//		printf("%d ", eqTuple->member[i]);
//	}
//	printf("\n");
//	printf("      isSen :%p\n", eqTuple->isSen);
//	printf("             ");
//	for (i = 0; i < eqTuple->noOfMember; i++)
//	{
//		printf("%d ", eqTuple->isSen[i]);
//	}
//	printf("\n");
//}

	if (eqTuple->noOfMember > 0)
	{
		free(eqTuple->member);
		free(eqTuple->isSen);
	}

	eqTuple->noOfMember = eqTuple->noOfMember - returnValue->noOfMember;
	eqTuple->noOfSen = 0; 

	
//if (isFlag == 1)
//printf("   ~~~~~~ haha10..\n");
	eqTuple->member = newMember;
	eqTuple->isSen = newIsSen;

	return returnValue;
}


void removeLastOne(equivalenceClass *proEqClass, configure *conf, equivalenceClass *finalEqClass, int *noOfPotentTrunk)
{
	equivalenceTuple **eqTuple;
	equivalenceTuple *eqOne;
	equivalenceTuple *eqNew;

	(*noOfPotentTrunk) = 0;

	if (proEqClass->noOfEqClass == 1)
	{
		eqTuple = proEqClass->eqClass;
	}
	else
	{
		return;
	}

	//for (i = 0; i < noOfPotentialTrunk; i++)
	{
		//eqOne = &(eqTuple[0]);
		eqOne = eqTuple[0];

		// split the equivalence class into trunks and stubs
		eqNew = splitEqClass_LastOne(eqOne, conf);

		// insert the trunks into the finalEqClass
		insertEqTupleIntoEqClass(finalEqClass, eqNew);
		// cannot free eqNew (due to the content still in finalEqClass)

	}

}



int *removePreciseAlphaTrunk(equivalenceClass *proEqClass, configure *conf, equivalenceClass *finalEqClass, int *noOfPotentTrunk)
{
	int noOfPotentialTrunk;
	int *listOfPotentialTrunk;

	equivalenceTuple **eqTuple;
	equivalenceTuple *eqOne;
	equivalenceTuple *eqNew;

	int i;

	// find the eq. class with potential trunks
	listOfPotentialTrunk = getListEqClass_PotentialTrunk(proEqClass, conf, &noOfPotentialTrunk);

	eqTuple = proEqClass->eqClass;
//printf("~~~~~ray1\n");
	for (i = 0; i < noOfPotentialTrunk; i++)
	{
//if (i==  1646) 
//{
//printf("    %d\n", i);
//isFlag = 1;
//}

		//eqOne = &(eqTuple[listOfPotentialTrunk[i]]);
		eqOne = eqTuple[listOfPotentialTrunk[i]];
//if (i==  1646) 
//{
//printf("~~~~~ray1.1\n");
//}
		// split the equivalence class into trunks and stubs
		eqNew = splitEqClass_Trunk(eqOne, conf);
//if (i==  1646) 
//printf("~~~~~ray1.2\n");
		// insert the trunks into the finalEqClass
		insertEqTupleIntoEqClass(finalEqClass, eqNew);
		// cannot free eqNew (due to the content still in finalEqClass)
//if (i==  1646) 
//{
//printf("~~~~~ray1.3\n");
//isFlag = 0;
//}

	}
//printf("~~~~~ray2\n");
	(*noOfPotentTrunk) = noOfPotentialTrunk;

	return listOfPotentialTrunk;
}



void updateFinalEquivalenceClassWithStub(equivalenceClass *finalEqClass, int eqNo, equivalenceTuple *eqOne, int noOfRemove)
{
	equivalenceTuple **finalEqTuple;
	equivalenceTuple *finalEqOne;

	int noOfFinalMember, noOfProMember;
	int *finalMember;
	int *finalIsSen;
	int *proMember;
	int *proIsSen;
	int *newProMember;
	int *newProIsSen;

	if (noOfRemove <= 0)
	{
		return;
	}

	noOfProMember = eqOne->noOfMember;
	if (noOfProMember > 0)
	{
		finalEqTuple = finalEqClass->eqClass;
		//finalEqOne = &(finalEqTuple[eqNo]);
		finalEqOne = finalEqTuple[eqNo];
		finalMember = finalEqOne->member;
		finalIsSen = finalEqOne->isSen;
		proMember = eqOne->member;
		proIsSen = eqOne->isSen;

		noOfFinalMember = finalEqOne->noOfMember;
		


		finalMember = (int *) realloc(finalMember, sizeof(int)*(noOfFinalMember+noOfRemove));

		memcpy(&(finalMember[noOfFinalMember]), proMember, sizeof(int)*noOfRemove);


		// added
		finalIsSen = (int *) realloc(finalIsSen, sizeof(int)*(noOfFinalMember+noOfRemove));
		memcpy(&(finalIsSen[noOfFinalMember]), proIsSen, sizeof(int)*noOfRemove);

		finalEqOne->member = finalMember;
		//finalEqOne->noOfMember += noOfProMember;
		finalEqOne->noOfMember += noOfRemove;
		// no need to concern about sensitive attr (as all attr has been removed)

		

		if (noOfRemove == noOfProMember)
		{
			eqOne->noOfMember = 0;
			free(proMember);

		}
		else
		{
			eqOne->noOfMember = noOfProMember-noOfRemove;

			newProMember = (int *) malloc(sizeof(int)*eqOne->noOfMember);
			memcpy(newProMember, &(proMember[noOfRemove]), sizeof(int)*eqOne->noOfMember);

			// added
			newProIsSen = (int *) malloc(sizeof(int)*eqOne->noOfMember);
			memcpy(newProIsSen, &(proIsSen[noOfRemove]), sizeof(int)*eqOne->noOfMember);
			

			eqOne->member = newProMember;
			eqOne->isSen = newProIsSen;

			free(proMember);
			free(proIsSen);
		}
	}
}

void insertFinalEquivalenceClassWithFurtherRemoval(equivalenceClass *finalEqClass, equivalenceTuple *proEqOne, int noOfRemoval)
{
	equivalenceTuple *newEqTuple;

	int noOfMember;

	int *newMember;
	int *oldMember;

	int *newIsSen;
	int *oldIsSen;
	int i;
	int newNoOfIsSen;
	int oldNoOfIsSen;

	int *oldIsSen2;
	int *oldMember2;

	// mem cpy
	newEqTuple = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	memcpy(newEqTuple, proEqOne, sizeof(equivalenceTuple));

	noOfMember = proEqOne->noOfMember;

	if (noOfRemoval == noOfMember)
	{
		proEqOne->noOfMember = 0;
	}
	else
	{
		proEqOne->noOfMember = noOfMember-noOfRemoval;
		newEqTuple->noOfMember = noOfRemoval;

		oldNoOfIsSen = proEqOne->noOfSen;

		// create a new list
		oldMember = newEqTuple->member;
		newMember = (int *) malloc(sizeof(int)*noOfRemoval);
		memcpy(newMember, oldMember, sizeof(int)*noOfRemoval);

		oldIsSen = newEqTuple->isSen;
		newIsSen = (int *) malloc(sizeof(int)*noOfRemoval);
		memcpy(newIsSen, oldIsSen, sizeof(int)*noOfRemoval);

		//
		oldMember2 = (int *) malloc(sizeof(int)*proEqOne->noOfMember);
		memcpy(oldMember2, &(oldMember[noOfRemoval]), sizeof(int)*proEqOne->noOfMember);

		oldIsSen2 = (int *) malloc(sizeof(int)*proEqOne->noOfMember);
		memcpy(oldIsSen2, &(oldIsSen[noOfRemoval]), sizeof(int)*proEqOne->noOfMember);
		
		// free
		free(oldMember);
		free(oldIsSen);

		// no. of sen
		newNoOfIsSen = 0;
		for (i = 0; i < noOfRemoval; i++)
		{
			if (newIsSen[i] == 1)
			{
				newNoOfIsSen++;
			}
		}

		// 
		oldNoOfIsSen = oldNoOfIsSen - newNoOfIsSen;

		// update
		newEqTuple->member = newMember;
		newEqTuple->isSen = newIsSen;
		newEqTuple->noOfSen = newNoOfIsSen;

		proEqOne->member = oldMember2;
		proEqOne->isSen = oldIsSen2;
		proEqOne->noOfSen = oldNoOfIsSen;

		
	}

	// 
	insertEqTupleIntoEqClass(finalEqClass, newEqTuple);
	
}


void furtherRemoval(equivalenceClass *finalEqClass, equivalenceClass *proEqClass, configure *config, int *isProcess, int noOfFurtherRemoval)
{
	int i;
	int noOfMember;

	int totalRemoved;

	equivalenceTuple **proEqTuple;
	equivalenceTuple *proEqOne;

	int isAlphaK;

	int noOfRemoval;
	int processLastOne;

	proEqTuple = proEqClass->eqClass;

	totalRemoved = 0;

	processLastOne = 0;

	for (i = 0; i < proEqClass->noOfEqClass; i++)
	{
		// if it has not processed yet
		if (isProcess[i] == 0)
		{
			//proEqOne = &(proEqTuple[i]);
			proEqOne = proEqTuple[i];
			noOfMember = proEqOne->noOfMember;

			// check whether there is K elements or more (and alpha constraints)
			isAlphaK = isAlphaKAnonymity_EquivalenceClass(proEqOne, config);
			if (isAlphaK == 1)
			{
				// can be further removed
				if (totalRemoved + noOfMember <= noOfFurtherRemoval)
				{
					noOfRemoval = noOfMember;
					insertFinalEquivalenceClassWithFurtherRemoval(finalEqClass, proEqOne, noOfRemoval);

					totalRemoved += noOfMember;
				}
				else
				{
					if (totalRemoved == noOfFurtherRemoval)
					{
						processLastOne = 1;
						break;
					}
					else
					{
						// check whether it is the last one
						if (processLastOne == 0)
						{
							// that means we may need to split the eq. class
							noOfRemoval = noOfFurtherRemoval-totalRemoved;
							// here
							if (noOfRemoval >= config->K)
							{
								insertFinalEquivalenceClassWithFurtherRemoval(finalEqClass, proEqOne, noOfRemoval);
							}
							else
							{
								// do nothing
							}

							processLastOne = 1;
							break;
						}
						else
						{
							break;
						}
					}
				}

				
			}
			else
			{
				// cannot be removed
			}
		}
	}
}

// assume there is NO equilvalence class deleted in the original proEqClass (even the no. of member = 0)
void removeGreatestPossTuples(equivalenceClass *proEqClass, configure *conf, equivalenceClass *finalEqClass, int *listOfPotentialTrunk, int noOfPotentialTrunk, int prevNoofFinalEqClass, int greatestCount)
{
	int i;

	int *isProcess;

	int totalCount;

	int processLastOne;

	int noOfRemoval;

	equivalenceTuple **proEqTuple;
	equivalenceTuple *proEqOne;

	int noOfMember;
	int noOfFurtherRemoval;

	proEqTuple = proEqClass->eqClass;

	totalCount = 0;

	processLastOne = 0;
	
	// processing potential stubs
	for (i = 0; i < noOfPotentialTrunk; i++)
	{

if (listOfPotentialTrunk[i] == 1668)
{
	printf("");
}

if (listOfPotentialTrunk[i] == 1669)
{
	printf("");
}

if (listOfPotentialTrunk[i] == 1670)
{
	printf("");
}




if (i == 1669)
{
	printf("");
}

if (i == 1670)
{
	printf("");
}



		//proEqOne = &(proEqTuple[listOfPotentialTrunk[i]]);
		proEqOne = proEqTuple[listOfPotentialTrunk[i]];

		noOfMember = proEqOne->noOfMember;

		if (totalCount + noOfMember <= greatestCount) 
		{
			if (noOfMember > 0)
			{
				// update the eq. class in finalEqClass
				noOfRemoval = noOfMember;
				updateFinalEquivalenceClassWithStub(finalEqClass, prevNoofFinalEqClass+i, proEqOne, noOfRemoval);

				// remove this eq. class in proEqClass
				// (do it in the later stops (in a batch)

				// update the totalCount
				totalCount += noOfMember;
			}
			else
			{
				// do nothing
			}
		}
		else
		{
			if (totalCount == greatestCount)
			{
				processLastOne = 1;
				break;
			}
			else
			{
				// check whether it is the last one
				if (processLastOne == 0)
				{
					// that means we may need to split proEqClass
					noOfRemoval = greatestCount-totalCount;
					updateFinalEquivalenceClassWithStub(finalEqClass, prevNoofFinalEqClass+i, proEqOne, noOfRemoval);
				 
					processLastOne = 1;
					break;
				}
				else
				{
					break;
				}
			}
		}
	}

	if (totalCount == greatestCount)
	{
			processLastOne = 1;
	}

	// check whether the last one was processed or not
	if (processLastOne == 0)
	{
		// check with other eq. class (which is not potential trunks)
		isProcess = (int *) malloc(sizeof(int)*proEqClass->noOfEqClass);
		memset(isProcess, 0, sizeof(int)*proEqClass->noOfEqClass);

		for (i = 0; i < noOfPotentialTrunk; i++)
		{
			isProcess[listOfPotentialTrunk[i]] = 1;
		}

		// 
		noOfFurtherRemoval = greatestCount - totalCount;
		furtherRemoval(finalEqClass, proEqClass, conf, isProcess, noOfFurtherRemoval);
		

		free(isProcess);
	}
	else
	{
		// do nothing
	}

	// remove all eq. class with zero members in proEqClass
	removeEquivalenceClassWithZeroMember(proEqClass);
	
}

int *createListFromEquivalenceClass(data *dataSet, equivalenceClass *eqClass, int noOfDim, int *dimNo)
{
	int *returnValue;

	int i, j;
	int dim;

	equivalenceTuple **eqTuple;

	eqTuple = eqClass->eqClass;

	returnValue = (int *) malloc(sizeof(int)*(eqClass->noOfEqClass));
	memset(returnValue, 0, sizeof(int)*(eqClass->noOfEqClass));

	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		for (j = 0; j < noOfDim; j++)
		{
			dim = dimNo[j];

			//returnValue[i] = returnValue[i]*dataSet->dimSize[dim] + eqTuple[i].content[dim].value;
			returnValue[i] = returnValue[i]*dataSet->dimSize[dim] + eqTuple[i]->content[dim].value;
		}
	}

	return returnValue;

}

void mergeEqClass(equivalenceClass *eqClass, data *dataSet, configure *conf)
{
	equivalenceTuple **newEqTuple;
	equivalenceTuple **orgEqTuple;

	int *dimNo;
	int noOfDim;

	int i, j;

	int *combineList;

	int newNoOfEqClass;

	int prevValue;

	int senAttrNo;
	//int SEN_VALUE;
	int noOfSen;
	int noOfMember;
	int *index;
	int *eqIndex;
	int *newMember;
	int *newIsSen;
	equivalenceTuple *orgEqOne;

	// dim (temp)
	noOfDim = dataSet->noOfDim-1;
	dimNo = (int *) malloc(sizeof(int)*noOfDim);
	for (i = 0; i < noOfDim; i++)
	{
		dimNo[i] = i;
	}

	// create list from the equivalence class
	combineList = createListFromEquivalenceClass(dataSet, eqClass, noOfDim, dimNo);

	

	// sort 
	index = (int *) malloc(sizeof(int)*eqClass->noOfEqClass);
	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		index[i] = i;
	}
	quicksort_i(index, combineList, 0, eqClass->noOfEqClass-1);

	// count no. of new eq. classes
	prevValue = -1;
	newNoOfEqClass = 0;
	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		if (prevValue != combineList[i])
		{
			newNoOfEqClass++;
			prevValue = combineList[i];
		}
	}

	newEqTuple = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *)*newNoOfEqClass);

	eqIndex = (int *) malloc(sizeof(int)*(newNoOfEqClass+1));
	memset(eqIndex, 0, sizeof(int)*(newNoOfEqClass+1));

	// find the index
	prevValue = -1;
	newNoOfEqClass = 0;
	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		if (prevValue != combineList[i])
		{
			eqIndex[newNoOfEqClass] = i;

			newNoOfEqClass++;
			prevValue = combineList[i];
		}
	}
	eqIndex[newNoOfEqClass] = eqClass->noOfEqClass;

	// Assume only one sensitve value
	orgEqTuple = eqClass->eqClass;
	senAttrNo = conf->senAttrNo[0];
	//SEN_VALUE = 1;
	for (i = 0; i < newNoOfEqClass; i++)
	{
		newEqTuple[i] = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
		memset(newEqTuple[i], 0, sizeof(equivalenceTuple));

		noOfMember = 0;
		noOfSen = 0;
		newMember = NULL;
		newIsSen = NULL;

		newEqTuple[i]->id = orgEqTuple[index[eqIndex[i]]]->id;	// assume at least one tuple

		newEqTuple[i]->content = (dimension *) malloc(sizeof(dimension)*conf->noOfDim);
		memcpy(newEqTuple[i]->content, orgEqTuple[index[eqIndex[i]]]->content, sizeof(dimension)*conf->noOfDim);
		// although we copied the sensitve attr (but we will not use it)


		for (j = eqIndex[i]; j < eqIndex[i+1]; j++)
		{

			//orgEqOne = &(orgEqTuple[index[j]]);
			orgEqOne = orgEqTuple[index[j]];

			if (noOfMember == 0)
			{
				newMember = (int *) malloc(sizeof(int)*orgEqOne->noOfMember);
				newIsSen = (int *) malloc(sizeof(int)*orgEqOne->noOfMember);
			}
			else
			{
				newMember = (int *) realloc(newMember, sizeof(int)*(noOfMember+orgEqOne->noOfMember));
				newIsSen = (int *) realloc(newIsSen, sizeof(int)*(noOfMember+orgEqOne->noOfMember));
			}
			memcpy(&(newMember[noOfMember]), orgEqOne->member, sizeof(int)*orgEqOne->noOfMember);
			memcpy(&(newIsSen[noOfMember]), orgEqOne->isSen, sizeof(int)*orgEqOne->noOfMember);
			free(orgEqOne->member);
			free(orgEqOne->isSen);


			noOfMember += orgEqOne->noOfMember;
			noOfSen += orgEqOne->noOfSen;

			// newly added
			free(orgEqOne->content);
			free(orgEqOne);
		}

		

		newEqTuple[i]->noOfMember = noOfMember;
		newEqTuple[i]->noOfSen = noOfSen;
		newEqTuple[i]->member = newMember;
		newEqTuple[i]->isSen = newIsSen;
		

		
		
	}

	free(orgEqTuple);

	eqClass->eqClass = newEqTuple;
	eqClass->noOfEqClass = newNoOfEqClass;

	free(index);
	free(combineList);

	// newly added
	free(eqIndex);
	free(dimNo);
}

void outputGeneralizedData(equivalenceClass *eqClass, configure *conf, data *orgDataSet)
{
	FILE *filePtr;

	//int i;

	filePtr = (FILE *) fopen(conf->genDataFilename, "w");

	
	// to be completed

	fclose(filePtr);
}

float distanceMeasure(int level, int noOfLevel)
{
	float returnValue;

	// uniform
	returnValue = 1.0;

	// height weights
	//returnValue = (float) (1.0/(noOfLevel-1-level));

	return returnValue;
}

float distanceMeasureTotal(int noOfLevel)
{
	float returnValue;
	int i;

	returnValue = 0;

	for (i = 0; i < noOfLevel-1; i++)
	{
		returnValue += distanceMeasure(i, noOfLevel); 
	}

	return returnValue;
}

void calculateDistanceBetweenDimension(generalizedDimTable *genDimTable, dimension *dim1, dimension *dim2, float *dist1, float *dist2)
{
	int noOfLevel;

	dimension *tempDim1;
	dimension *tempDim2;

	float WHD_value, WHD_total;

	int level;

	generalizedLevelTable *genLevelTable;
	generalizedLevelTable *gen;

	(*dist1) = 0;
	(*dist2) = 0;

	// clone the dimensions
	tempDim1 = (dimension *) malloc(sizeof(dimension));
	tempDim2 = (dimension *) malloc(sizeof(dimension));

	memcpy(tempDim1, dim1, sizeof(dimension));
	memcpy(tempDim2, dim2, sizeof(dimension));

	noOfLevel = genDimTable->noOfLevel;
	gen = genDimTable->gen;



	// making to both to the same levels
	if (tempDim1->level > tempDim2->level)
	{
		while (tempDim1->level > tempDim2->level)
		{
			// generalize tempDim2
			level = tempDim2->level;
			genLevelTable = &(gen[level]);
			generalizeDimension(tempDim2, genLevelTable);

			WHD_value = distanceMeasure(level, noOfLevel);
			(*dist2) += WHD_value;
		}
	}
	else if (tempDim1->level < tempDim2->level)
	{
		while (tempDim1->level < tempDim2->level)
		{
			// generalize tempDim1
			level = tempDim1->level;
			genLevelTable = &(gen[level]);
			generalizeDimension(tempDim1, genLevelTable);

			WHD_value = distanceMeasure(level, noOfLevel);
			(*dist1) += WHD_value;
		}
	}

	// now, both have the same levels
	// generalize both if they don't have the same value
	while (tempDim1->value != tempDim2->value)
	{
		// generalize tempDim1
		level = tempDim1->level;
		genLevelTable = &(gen[level]);
		generalizeDimension(tempDim1, genLevelTable);

		WHD_value = distanceMeasure(level, noOfLevel);
		(*dist1) += WHD_value;

		// generalize tempDim2
		level = tempDim2->level;
		genLevelTable = &(gen[level]);
		generalizeDimension(tempDim2, genLevelTable);

		WHD_value = distanceMeasure(level, noOfLevel);
		(*dist2) += WHD_value;
	}

	WHD_total = distanceMeasureTotal(noOfLevel);
	//returnValue = returnValue/WDH_total;
	(*dist1) /= WHD_total;
	(*dist2) /= WHD_total;

	free(tempDim1);
	free(tempDim2);

}



dimension *generalizeTwoDimension(generalizedDimTable *genDimTable, dimension *dim1, dimension *dim2)
{
	dimension *returnValue;
	int noOfLevel;

	dimension *tempDim1;
	dimension *tempDim2;

	int level;

	generalizedLevelTable *genLevelTable;
	generalizedLevelTable *gen;

	returnValue = (dimension *) malloc(sizeof(dimension));


	// clone the dimensions
	tempDim1 = (dimension *) malloc(sizeof(dimension));
	tempDim2 = (dimension *) malloc(sizeof(dimension));

	memcpy(tempDim1, dim1, sizeof(dimension));
	memcpy(tempDim2, dim2, sizeof(dimension));

	noOfLevel = genDimTable->noOfLevel;
	gen = genDimTable->gen;



	// making to both to the same levels
	if (tempDim1->level > tempDim2->level)
	{
		while (tempDim1->level > tempDim2->level)
		{
			// generalize tempDim2
			level = tempDim2->level;
			genLevelTable = &(gen[level]);
			generalizeDimension(tempDim2, genLevelTable);
		}
	}
	else if (tempDim1->level < tempDim2->level)
	{
		while (tempDim1->level < tempDim2->level)
		{
			// generalize tempDim1
			level = tempDim1->level;
			genLevelTable = &(gen[level]);
			generalizeDimension(tempDim1, genLevelTable);
		}
	}

	// now, both have the same levels
	// generalize both if they don't have the same value
	while (tempDim1->value != tempDim2->value)
	{
		// generalize tempDim1
		level = tempDim1->level;
		genLevelTable = &(gen[level]);
		generalizeDimension(tempDim1, genLevelTable);

		// generalize tempDim2
		level = tempDim2->level;
		genLevelTable = &(gen[level]);
		generalizeDimension(tempDim2, genLevelTable);
	}

	memcpy(returnValue, tempDim1, sizeof(dimension));

	free(tempDim1);
	free(tempDim2);

	return returnValue;

}


void equivalenceTuple_generateGeneralizedValue(data *aData, equivalenceTuple *aEqTuple, generalizedAllTable *genAllTable, int noOfDim)
{
	int i, j;

	int noOfMember;
	int *member;

	tuple *aTuple;

	int memberID;

	tuple *tupleList;

	dimension *dim1;
	dimension *dim2;

	dimension *newDim;

	tupleList = aData->tupleList;

	aEqTuple->content = (dimension *) malloc(sizeof(dimension)*noOfDim);
	memset(aEqTuple->content, 0, sizeof(dimension)*noOfDim);

	dim1 = aEqTuple->content;

	noOfMember = aEqTuple->noOfMember;
	member = aEqTuple->member;

	if (noOfMember > 0)
	{
		memberID = member[0];
		aTuple = &(tupleList[memberID]);
		memcpy(aEqTuple->content, aTuple->content, sizeof(dimension)*noOfDim);

		for (j = 1; j < noOfMember; j++)
		{
			memberID = member[j];
			aTuple = &(tupleList[memberID]);

			dim2 = aTuple->content;

			for (i = 0; i < noOfDim-1; i++)
			{
				newDim = generalizeTwoDimension(&(genAllTable->genDimTable[i]), &(dim1[i]), &(dim2[i]));

				memcpy(&(aEqTuple->content[i]), newDim, sizeof(dimension));

				free(newDim);
			}
		}
	}
}

void equivalenceClass_generateGeneralizedValue(equivalenceClass *eqClass, data *aData, generalizedAllTable *genAllTable, int noOfDim)
{
	int noOfEqTuple;

	equivalenceTuple **eqTupleList;
	equivalenceTuple *aEqTuple;

	int i;

	noOfEqTuple = eqClass->noOfEqClass;
	eqTupleList = eqClass->eqClass;

	for (i = 0; i < noOfEqTuple; i++)
	{
		aEqTuple = eqTupleList[i];
		equivalenceTuple_generateGeneralizedValue(aData, aEqTuple, genAllTable, noOfDim);
	}
}


float calculateDistanceBetweenEquivalenceTuple(configure *conf, generalizedAllTable *genAllTable, equivalenceTuple *eqTuple1, equivalenceTuple *eqTuple2)
{
	float returnValue;

	dimension *dim1;
	dimension *dim2;

	int n1, n2;

	float dist1, dist2;

	int noOfDim, K;

	float distortion1, distortion2;

	int i;

	noOfDim = conf->noOfDim;
	K = conf->K;

	distortion1 = 0.0;
	distortion2 = 0.0;

	dim1 = eqTuple1->content;
	dim2 = eqTuple2->content;

	// for each dim (minus the last sensitive attr.)
	for (i = 0; i < noOfDim-1; i++)
	{
		
		calculateDistanceBetweenDimension(&(genAllTable->genDimTable[i]), &(dim1[i]), &(dim2[i]), &dist1, &dist2);
		
		distortion1 += dist1;
		distortion2 += dist2;
	}

	n1 = eqTuple1->noOfMember;
	n2 = eqTuple2->noOfMember;

	if ((n1+n2) < 2*K)
	{
		// do nothing
	}
	else
	{
		if (n1 >= K)
		{
			n1 = K - n2;
		}
		else
		{
			n2 = K - n1;
		}
	}

	returnValue = n1*distortion1 + n2*distortion2;

	return returnValue;
}


equivalenceTuple *mergeTwoEquivalenceTuple(int noOfDim, generalizedAllTable *genAllTable, equivalenceTuple *eqTuple1, equivalenceTuple *eqTuple2)
{
	equivalenceTuple * returnValue;

	int i;

	dimension *dim1;
	dimension *dim2;

	dimension *newDim;


	int no;

	returnValue = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));

	returnValue->content = (dimension *) malloc(sizeof(dimension)*noOfDim);
	memset(returnValue->content, 0, sizeof(dimension)*noOfDim);
	returnValue->noOfMember = eqTuple1->noOfMember+eqTuple2->noOfMember;
	returnValue->noOfSen = eqTuple1->noOfSen+eqTuple2->noOfSen;
	returnValue->member = (int *) malloc(sizeof(int)*returnValue->noOfMember);
	returnValue->isSen = (int *) malloc(sizeof(int)*returnValue->noOfMember);
	memset(returnValue->member, 0, sizeof(int)*returnValue->noOfMember);
	memset(returnValue->isSen, 0, sizeof(int)*returnValue->noOfMember);
	returnValue->id = eqTuple1->id;	//randomly choose one of the id

	// add member and isSen
	no = 0;
	for (i = 0; i < eqTuple1->noOfMember; i++)
	{
		returnValue->member[no] = eqTuple1->member[i];
		returnValue->isSen[no] = eqTuple1->isSen[i];
		no++;
	}
	for (i = 0; i < eqTuple2->noOfMember; i++)
	{
		returnValue->member[no] = eqTuple2->member[i];
		returnValue->isSen[no] = eqTuple2->isSen[i];
		no++;
	}


	// for content part

	dim1 = eqTuple1->content;
	dim2 = eqTuple2->content;

	// for each dim (minus the last sensitive attr.)
	for (i = 0; i < noOfDim-1; i++)
	{
		newDim = generalizeTwoDimension(&(genAllTable->genDimTable[i]), &(dim1[i]), &(dim2[i]));

		memcpy(&(returnValue->content[i]), newDim, sizeof(dimension));

		free(newDim);
		
	}

	return returnValue;
}


equivalenceTuple *mergeTwoEquivalenceTupleWithSenAndSenIndex(int noOfDim, generalizedAllTable *genAllTable, equivalenceTuple *eqTuple1, equivalenceTuple *eqTuple2, int noOfSenValue, int noOfSenIndex)
{
	equivalenceTuple * returnValue;

	int i;

	dimension *dim1;
	dimension *dim2;

	dimension *newDim;


	int no;

	returnValue = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	memset(returnValue, 0, sizeof(equivalenceTuple));

	returnValue->content = (dimension *) malloc(sizeof(dimension)*noOfDim);
	memset(returnValue->content, 0, sizeof(dimension)*noOfDim);
	returnValue->noOfMember = eqTuple1->noOfMember+eqTuple2->noOfMember;
	//returnValue->noOfSen = eqTuple1->noOfSen+eqTuple2->noOfSen;
	returnValue->member = (int *) malloc(sizeof(int)*returnValue->noOfMember);
	//returnValue->isSen = (int *) malloc(sizeof(int)*returnValue->noOfMember);
	memset(returnValue->member, 0, sizeof(int)*returnValue->noOfMember);
	//memset(returnValue->isSen, 0, sizeof(int)*returnValue->noOfMember);
	returnValue->id = eqTuple1->id;	//randomly choose one of the id

	// add member and isSen
	no = 0;
	for (i = 0; i < eqTuple1->noOfMember; i++)
	{
		returnValue->member[no] = eqTuple1->member[i];
		//returnValue->isSen[no] = eqTuple1->isSen[i];
		no++;
	}
	for (i = 0; i < eqTuple2->noOfMember; i++)
	{
		returnValue->member[no] = eqTuple2->member[i];
		//returnValue->isSen[no] = eqTuple2->isSen[i];
		no++;
	}


	// for content part

	dim1 = eqTuple1->content;
	dim2 = eqTuple2->content;

	// for each dim (minus the last sensitive attr.)
	for (i = 0; i < noOfDim-1; i++)
	{
		newDim = generalizeTwoDimension(&(genAllTable->genDimTable[i]), &(dim1[i]), &(dim2[i]));

		memcpy(&(returnValue->content[i]), newDim, sizeof(dimension));

		free(newDim);
		
	}

	// noOfEachSen 
	returnValue->noOfEachSen = (int *) malloc(sizeof(int)*noOfSenValue);
	memset(returnValue->noOfEachSen, 0, sizeof(int)*noOfSenValue);
	for (i = 0; i < noOfSenValue; i++)
	{
		returnValue->noOfEachSen[i] += eqTuple1->noOfEachSen[i];
		returnValue->noOfEachSen[i] += eqTuple2->noOfEachSen[i];
	}

	// noOfEachSenIndex
	returnValue->noOfEachSenIndex = (int *) malloc(sizeof(int)*noOfSenIndex);
	memset(returnValue->noOfEachSenIndex, 0, sizeof(int)*noOfSenIndex);
	for (i = 0; i < noOfSenIndex; i++)
	{
		returnValue->noOfEachSenIndex[i] += eqTuple1->noOfEachSenIndex[i];
		returnValue->noOfEachSenIndex[i] += eqTuple2->noOfEachSenIndex[i];
	}

	return returnValue;
}

equivalenceClass *cloneEquivalenceClass(equivalenceClass *eqClass, configure *conf)
{
	equivalenceClass *returnValue;

	//int noOfAttr;
	//int *list;

	//int *isProject;

	int i;//, j;
	//int no;

	int noOfEqTuple;
	int noOfDim;
	equivalenceTuple **eqTuple;
	equivalenceTuple **newEqTuple;
	equivalenceTuple *oneNewEqTuple;
	equivalenceTuple *oneEqTuple;

	noOfEqTuple = eqClass->noOfEqClass;
	eqTuple = eqClass->eqClass;

	noOfDim = conf->noOfDim;
	

	returnValue = (equivalenceClass *) malloc(sizeof(equivalenceClass));
	memset(returnValue, 0, sizeof(equivalenceClass));
	returnValue->noOfEqClass = noOfEqTuple;
	newEqTuple = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *)*noOfEqTuple);

	returnValue->eqClass = newEqTuple;


	for (i = 0; i < noOfEqTuple; i++)
	{
		oneNewEqTuple = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
		memset(oneNewEqTuple, 0, sizeof(equivalenceTuple));

		newEqTuple[i] = oneNewEqTuple;
		oneEqTuple = eqTuple[i];

		memcpy(oneNewEqTuple, oneEqTuple, sizeof(equivalenceTuple));

		oneNewEqTuple->member = (int *) malloc(sizeof(int)*oneEqTuple->noOfMember);
		oneNewEqTuple->isSen = (int *) malloc(sizeof(int)*oneEqTuple->noOfMember);

		memcpy(oneNewEqTuple->member, oneEqTuple->member, sizeof(int)*oneEqTuple->noOfMember);
		memcpy(oneNewEqTuple->isSen, oneEqTuple->isSen, sizeof(int)*oneEqTuple->noOfMember);

		oneNewEqTuple->content = (dimension *) malloc(sizeof(dimension)*noOfDim);
		memcpy(oneNewEqTuple->content, oneEqTuple->content, sizeof(dimension)*noOfDim);

	}

	return returnValue;
}


equivalenceClass *cloneEquivalenceClassWithProjection(equivalenceClass *eqClass, int noOfDim, AttributeList *attrList, data *dataSet, configure *conf)
{
	equivalenceClass *returnValue;

	int noOfAttr;
	int *list;

	int *isProject;

	int i, j;
	int no;

	int noOfEqTuple;
	equivalenceTuple **eqTuple;
	equivalenceTuple **newEqTuple;
	equivalenceTuple *oneNewEqTuple;
	equivalenceTuple *oneEqTuple;

	noOfEqTuple = eqClass->noOfEqClass;
	eqTuple = eqClass->eqClass;
	

	returnValue = (equivalenceClass *) malloc(sizeof(equivalenceClass));
	returnValue->noOfEqClass = noOfEqTuple;
	newEqTuple = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *)*noOfEqTuple);

	returnValue->eqClass = newEqTuple;

	// attr
	// find which attr. to be projected
	noOfAttr = attrList->noOfAttr;
	list = attrList->attr;

	isProject = (int *) malloc(sizeof(int)*(noOfDim-1));
	memset(isProject, 0, sizeof(int)*(noOfDim-1));

	for (i = 0; i < noOfAttr; i++)
	{
		no = list[i];
		isProject[no] = 1;
	}

	for (i = 0; i < noOfEqTuple; i++)
	{
		oneNewEqTuple = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
		memset(oneNewEqTuple, 0, sizeof(equivalenceTuple));

		newEqTuple[i] = oneNewEqTuple;
		oneEqTuple = eqTuple[i];

		memcpy(oneNewEqTuple, oneEqTuple, sizeof(equivalenceTuple));

		oneNewEqTuple->member = (int *) malloc(sizeof(int)*oneEqTuple->noOfMember);
		oneNewEqTuple->isSen = (int *) malloc(sizeof(int)*oneEqTuple->noOfMember);

		memcpy(oneNewEqTuple->member, oneEqTuple->member, sizeof(int)*oneEqTuple->noOfMember);
		memcpy(oneNewEqTuple->isSen, oneEqTuple->isSen, sizeof(int)*oneEqTuple->noOfMember);

		oneNewEqTuple->content = (dimension *) malloc(sizeof(dimension)*noOfDim);
		memcpy(oneNewEqTuple->content, oneEqTuple->content, sizeof(dimension)*noOfDim);

		// project
		for (j = 0; j < noOfDim-1; j++)
		{
			if (isProject[j] == 0)
			{
				// if not projected , mark the same value  (e.g. 0) for all eq. tuples
				oneNewEqTuple->content[j].level = 0;
				oneNewEqTuple->content[j].value = 0;
			}
		}
	}

	free(isProject);

	// merge
	mergeEqClass(returnValue, dataSet, conf);

	return returnValue;
}

equivalenceTuple *cloneEquivalenceTuple(equivalenceTuple *eqTuple, configure *conf)
{
	equivalenceTuple *returnValue;
	int noOfMember;

	int noOfDim;

	noOfDim = conf->noOfDim;

	noOfMember = eqTuple->noOfMember;

	returnValue = (equivalenceTuple *) malloc(sizeof(equivalenceTuple));
	memcpy(returnValue, eqTuple, sizeof(equivalenceTuple));

	if (eqTuple->content == NULL)
	{
		returnValue->content = NULL;
	}
	else
	{
		returnValue->content = (dimension *) malloc(sizeof(dimension)*noOfDim);
		memcpy(returnValue->content, eqTuple->content, sizeof(dimension)*noOfDim);
	}

	returnValue->member = (int *) malloc(sizeof(int)*noOfMember);
	returnValue->isSen = (int *) malloc(sizeof(int)*noOfMember);
	if (eqTuple->senValue != NULL)
	{
		returnValue->senValue = (dimension *) malloc(sizeof(dimension)*noOfMember);
	}

	memcpy(returnValue->member, eqTuple->member, sizeof(int)*noOfMember);
	memcpy(returnValue->isSen, eqTuple->isSen, sizeof(int)*noOfMember);
	if (eqTuple->senValue != NULL)
	{
		memcpy(returnValue->senValue, eqTuple->senValue, sizeof(dimension)*noOfMember);
	}

	return returnValue;
}


void freeEquivalenceTuple(equivalenceTuple *eqTuple)
{
	if (eqTuple->content != NULL)
	{
		free(eqTuple->content);
	}

	if (eqTuple->noOfMember > 0)
	{
		if (eqTuple->member != NULL)
		{
			free(eqTuple->member);
		}
		if (eqTuple->isSen != NULL)
		{
			free(eqTuple->isSen);
		}
		if (eqTuple->senValue != NULL)
		{
			free(eqTuple->senValue);
		}
	}
}


void freeEquivalenceTupleWithSenValueAndSenIndex(equivalenceTuple *eqTuple)
{
	free(eqTuple->content);

	if (eqTuple->noOfMember > 0)
	{
		free(eqTuple->member);
		//free(eqTuple->isSen);
		free(eqTuple->noOfEachSen);
		free(eqTuple->noOfEachSenIndex);
	}

	free(eqTuple);
}


void freeEquivalenceClass(equivalenceClass *eqClass)
{
	int noOfEqClass;
	equivalenceTuple **eqTuple;

	int i;

	noOfEqClass = eqClass->noOfEqClass;
	eqTuple = eqClass->eqClass;

	for (i = 0; i < noOfEqClass; i++)
	{
		freeEquivalenceTuple(eqTuple[i]);
		free(eqTuple[i]);
	}
	free(eqTuple);
}

// mrege index1 and index2
// remove index2
void equivalenceClass_mergeTwoEqTuple_withRemove_forNormal(equivalenceClass *eqClass, int index1, int index2)
{
	equivalenceTuple **eqTupleList;

	equivalenceTuple *eqTuple1;
	equivalenceTuple *eqTuple2;

	int noOfMember1;
	int *member1;
	dimension *senValue1;
	int *isSen1;

	int noOfMember2;
	int *member2;
	dimension *senValue2;
	int *isSen2;

	int newNoOfMember;
	int *newMember;
	dimension *newSenValue;
	int *newIsSen;

	eqTupleList = eqClass->eqClass;

	eqTuple1 = eqTupleList[index1];
	eqTuple2 = eqTupleList[index2];

	noOfMember1 = eqTuple1->noOfMember;
	member1 = eqTuple1->member;
	senValue1 = eqTuple1->senValue;
	isSen1 = eqTuple1->isSen;

	noOfMember2 = eqTuple2->noOfMember;
	member2 = eqTuple2->member;
	senValue2 = eqTuple2->senValue;
	isSen2 = eqTuple2->isSen;

	newNoOfMember = noOfMember1 + noOfMember2;
	if (newNoOfMember > 0)
	{
		newMember = (int *) malloc(sizeof(int)*newNoOfMember);
		newSenValue = (dimension *) malloc(sizeof(dimension)*newNoOfMember);
		newIsSen = (int *) malloc(sizeof(int)*newNoOfMember);

		if (noOfMember1 > 0)
		{
			memcpy(newMember, member1, sizeof(int)*noOfMember1);
			memcpy(newSenValue, senValue1, sizeof(dimension)*noOfMember1);
			memcpy(newIsSen, senValue1, sizeof(int)*noOfMember1);

			free(member1);
			free(senValue1);
			free(isSen1);
		}

		if (noOfMember2 > 0)
		{
			memcpy(&(newMember[noOfMember1]), member2, sizeof(int)*noOfMember2);
			memcpy(&(newSenValue[noOfMember1]), senValue2, sizeof(dimension)*noOfMember2);
			memcpy(&(newIsSen[noOfMember1]), senValue2, sizeof(int)*noOfMember2);

			free(member2);
			free(senValue2);
			free(isSen2);
		}

		eqTuple1->member = newMember;
		eqTuple1->senValue = newSenValue;
		eqTuple1->isSen = newIsSen;
	}

	removeEqTupleFromEqClass(eqClass, index2);

}

// currently, assume there are only two sen. index.
void eq_createSenIndexForOneEqTuple(equivalenceTuple *aEqTuple, configure *config, int noOfSenValue, int noOfSenIndex)
{
	int *noOfEachSenIndex;

	int noOfMember;
	int *noOfEachSen;

	int i;

	int startSenValue;
	int endSenValue;

	startSenValue = config->senStartNo;
	endSenValue = config->senEndNo;

	if (aEqTuple->noOfEachSenIndex == NULL)
	{
		aEqTuple->noOfEachSenIndex = (int *) malloc(sizeof(int)*noOfSenIndex);
	}

	noOfEachSenIndex = aEqTuple->noOfEachSenIndex;
	// pls be careful for re-use to memory leakage
	memset(noOfEachSenIndex, 0, sizeof(int)*noOfSenIndex);

	noOfMember = aEqTuple->noOfMember;
	noOfEachSen = aEqTuple->noOfEachSen;

	for (i = 0; i < noOfSenValue; i++)
	{
		if ((startSenValue <= i) && (i <= endSenValue))
		{
			// 1 for sen. value
			noOfEachSenIndex[1] += noOfEachSen[i];
		}
		else
		{
			// 0 for non-sen. value
			noOfEachSenIndex[0] += noOfEachSen[i];
		}
	}
}

void eq_createSenIndexForAllEqTuple(equivalenceClass *eqClass, configure *config, int noOfSenValue, int noOfSenIndex)
{
	int i;

	equivalenceTuple **tupleList;
	equivalenceTuple *aEqTuple;

	int noOfEqTuple;

	noOfEqTuple = eqClass->noOfEqClass;
	tupleList = eqClass->eqClass;

	for (i = 0; i < noOfEqTuple; i++)
	{
		aEqTuple = tupleList[i];

		eq_createSenIndexForOneEqTuple(aEqTuple, config, noOfSenValue, noOfSenIndex);
	}
}



void eq_removeTwoEqTupleAndAddOneEqTupleToEqClass(equivalenceClass *eqClass, int removeEqID1, int removeEqID2, equivalenceTuple *eqTuple)
{
	if (removeEqID1 > removeEqID2)
	{
		removeEqTupleFromEqClass(eqClass, removeEqID1);
		removeEqTupleFromEqClass(eqClass, removeEqID2);
	}
	else
	{
		removeEqTupleFromEqClass(eqClass, removeEqID2);
		removeEqTupleFromEqClass(eqClass, removeEqID1);
	}

	insertEqTupleIntoEqClassWithoutClone(eqClass, eqTuple);

}


void equivalenceTuple_insertMember(equivalenceTuple *oneEqTuple, int id, data *aData, configure *config)
{
	int noOfDim;

	int *member;
	int *isSen;
	dimension *senValue;

	int noOfMember;
	
	noOfDim = aData->noOfDim;

	member = oneEqTuple->member;
	isSen = oneEqTuple->isSen;
	senValue = oneEqTuple->senValue;

	noOfMember = oneEqTuple->noOfMember;

	if (noOfMember == 0)
	{
		member = (int *) malloc(sizeof(int));
		isSen = (int *) malloc(sizeof(int));
		senValue = (dimension *) malloc(sizeof(dimension));
	}
	else
	{
		member = (int *) realloc(member, sizeof(int)*(noOfMember+1));
		isSen = (int *) realloc(isSen, sizeof(int)*(noOfMember+1));
		senValue = (dimension *) realloc(senValue, sizeof(dimension)*(noOfMember+1));
	}

	member[noOfMember] = id;
	senValue[noOfMember].level = 0;
	senValue[noOfMember].value = aData->tupleList[id].content[noOfDim-1].value;
	if ((config->senStartNo <= senValue[noOfMember].value) && (senValue[noOfMember].value <= config->senEndNo))
	{
		isSen[noOfMember] = 1;
	}
	else
	{
		isSen[noOfMember] = 0;
	}
			

	oneEqTuple->member = member;
	oneEqTuple->isSen = isSen;
	oneEqTuple->senValue = senValue;

	oneEqTuple->noOfMember++;


}

void progressiveMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable)
{
	FILE *debugFilePtr;

	int isAlphaK;

	summary *synopsis;
	equivalenceClass *proEqClass;
	equivalenceClass *finalEqClass;

	int noOfGreatestPossRemovalCount;

	int *listOfPotentialTrunk;
	int noOfPotentialTrunk;

	int prevNoOfFinalEqClass;

	int noOfRemain;

	int bestAttrNo;

	int iterationNo;

	double distortion;

#ifndef _WIN32
	float  userTime, sysTime;
	struct rusage myTime1, myTime2;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	debugFilePtr = (FILE *) fopen("debug.txt", "w");

	// create summary
	synopsis = createSummary(dataSet);

	// printing
	fprintf(debugFilePtr, "############## Summary ##################\n");
	printf("############## Summary ##################\n");
	printSummary(debugFilePtr, synopsis, conf->noOfDim);

	// check whether it is alphaK
	isAlphaK = isAlphaKAnonymity(dataSet, synopsis, conf);

	// 
	if (isAlphaK == 0)
	{
		printf("This data set cannot satisfy the alpha K anonymity!\n");
		exit(0);
	}
	else
	{
		// continue

		// generate equivalence class
		proEqClass = generateEquivalenceClass(dataSet, synopsis, conf); 

		// generate an empty equivalence class
		finalEqClass = new_equivalenceClass();

	

		// printing
		fprintf(debugFilePtr, "Starting.....\n");
		printf("Starting.....\n");
		fprintf(debugFilePtr, "############## proEqClass ##################\n");
		printf("############## proEqClass ##################\n");
		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//		printf("############## finalEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

		noOfRemain = proEqClass->noOfEqClass;
		iterationNo = 0;
		while (noOfRemain > 0)
		{
			iterationNo++;


//printf("~~~~~~~~~~~1\n");
			// special case handle for the last one
			if (noOfRemain == 1)
			{
				prevNoOfFinalEqClass = finalEqClass->noOfEqClass;
				removeLastOne(proEqClass, conf, finalEqClass, &noOfPotentialTrunk);
				listOfPotentialTrunk = NULL;
			}
			else
			{
//printf("~~~~~~~~~~~1.1\n");
				// find and remove all precise alpha-deassociatedTrunks
				prevNoOfFinalEqClass = finalEqClass->noOfEqClass;
//printf("~~~~~~~~~~~1.2\n");
				listOfPotentialTrunk = removePreciseAlphaTrunk(proEqClass, conf, finalEqClass, &noOfPotentialTrunk);
//printf("~~~~~~~~~~~1.3\n");

			}
//printf("~~~~~~~~~~~2\n");



			// printing
			fprintf(debugFilePtr, "Iteration %d.....\n", iterationNo);
			printf("Iteration %d.....\n", iterationNo);
			fprintf(debugFilePtr, "############## proEqClass ##################\n");
			printf("############## proEqClass ##################\n");
			printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
			fprintf(debugFilePtr, "############## finalEqClass ##################\n");
			printf("############## finalEqClass ##################\n");
			printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);
//printf("~~~~~~~~~~~3\n");
			// calculate the greatest poss. of removal
			noOfGreatestPossRemovalCount = calculateGreatestPossRemovalCount(proEqClass, conf);
//printf("~~~~~~~~~~~4\n");
			// remove noOfGreatestPossRemovalCount tuples
			removeGreatestPossTuples(proEqClass, conf, finalEqClass, listOfPotentialTrunk, noOfPotentialTrunk, prevNoOfFinalEqClass, noOfGreatestPossRemovalCount);
//printf("~~~~~~~~~~~5\n");
			// printing
			fprintf(debugFilePtr, "Iteration %d.....\n", iterationNo);
			printf("Iteration %d.....\n", iterationNo);




//printf("~~~~~~~~~~~6\n");
			noOfRemain = proEqClass->noOfEqClass;

			if (noOfRemain > 0)
			{
//printf("~~~~~~~~~~~7\n");
				// generalize the remanining tuples proEqClass
	
				// find the best attribute
				bestAttrNo = chooseBestAttribute(proEqClass, dataSet, conf);
//printf("~~~~~~~~~~~8\n");
				printf(" Best Attribute No. : %d\n", bestAttrNo);
				fprintf(debugFilePtr, " Best Attribute No. : %d\n", bestAttrNo);

				// generalize the tuples with that best attribute
				generalizeEqClass(proEqClass, bestAttrNo, conf, genAllTable);

//printf("~~~~~~~~~~~9\n");			

				// printing
				fprintf(debugFilePtr, "After Generalization .....\n");
				printf("After Generalization .....\n");
				
				// merge eq. class 
				mergeEqClass(proEqClass, dataSet, conf);
//printf("~~~~~~~~~~~10\n");
				// printing
				fprintf(debugFilePtr, "After Merging .....\n");
				printf("After Merging .....\n");

				printf("\n");



			}
			else
			{
				break;
			}
//printf("~~~~~~~~~~~11\n");
		}

		
	}

#ifndef _WIN32
	getrusage(RUSAGE_SELF, &myTime2);	
#endif

	printf("Calculating the distortion...\n");
	fprintf(debugFilePtr, "Calculating the distortion...\n");
	//double calculateDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable)
	distortion = (double) calculateDistortion(finalEqClass, conf, genAllTable);
	printf("Distortion: %.4f\n", distortion);
	fprintf(debugFilePtr, "Distortion: %.4f\n", distortion);
	

#ifndef _WIN32
	userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
	sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

	printf("User time : %f seconds\n",userTime);
	printf("System time : %f seconds\n\n",sysTime);

	fprintf(debugFilePtr, "Execution Time\n");
	fprintf(debugFilePtr, "--------------\n");
	fprintf(debugFilePtr, "User time : %f seconds\n",userTime);
    fprintf(debugFilePtr, "System time : %f seconds\n\n",sysTime);
#endif

	fclose(debugFilePtr);
}


void hierachicalMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable)
{
	FILE *debugFilePtr;

	int isAlphaK;

	summary *synopsis;
	equivalenceClass *proEqClass;
	equivalenceClass *finalEqClass;

	//int noOfGreatestPossRemovalCount;

	//int *listOfPotentialTrunk;
	//int noOfPotentialTrunk;

	//int prevNoOfFinalEqClass;

	int noOfRemain;

	//int bestAttrNo;

	int iterationNo;

	double distortion;

	Hash *hash;
	DistStorage *distStorage;
	int noOfSlot;
	float delta;

	float maxValue;

	int id;

#ifndef _WIN32
	float  userTime, sysTime;
	struct rusage myTime1, myTime2;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	if (conf->noOfTuple > 200)
	{
		noOfSlot = ((conf->noOfTuple*conf->noOfTuple)/200)-1;
	}
	else
	{
		noOfSlot = 5;
	}
	delta = 5.0f;

	maxValue = (float) (conf->noOfDim*2)*conf->noOfTuple/conf->K;

	debugFilePtr = (FILE *) fopen("debug.txt", "w");

	// preprocessing
	printf("Preprocessing....\n");
	prepProcessDataSet(dataSet, conf->K, genAllTable);

	// create summary
	printf("Creating Summary....\n");
	synopsis = createSummary(dataSet);

	// printing
//	fprintf(debugFilePtr, "############## Summary ##################\n");
//	printf("############## Summary ##################\n");
//	printSummary(debugFilePtr, synopsis, conf->noOfDim);

	// check whether it is alphaK
	//isAlphaK = isAlphaKAnonymity(dataSet, synopsis, conf);
	isAlphaK = 1;

	// 
	if (isAlphaK == 0)
	{
		printf("This data set cannot satisfy the alpha K anonymity!\n");
		exit(0);
	}
	else
	{
		// continue

		// generate equivalence class
		proEqClass = generateEquivalenceClass(dataSet, synopsis, conf); 

		// generate an empty equivalence class
		finalEqClass = new_equivalenceClass();

		// print eq. class
		//fprintf(debugFilePtr, "############## proEqClass ##################\n");
		//printf("############## proEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
		//fprintf(debugFilePtr, "############## finalEqClass ##################\n");
		//printf("############## finalEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

		// move the satisfied
		kDist_moveSatisfiedEqClass(proEqClass, finalEqClass, conf->K);

		// print eq. class
		//fprintf(debugFilePtr, "############## proEqClass ##################\n");
		//printf("############## proEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
		//fprintf(debugFilePtr, "############## finalEqClass ##################\n");
		//printf("############## finalEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);


		// generate the hash
		hash = hash_new(noOfSlot);

		// generate the distStorage
		distStorage = distStorage_new(delta, maxValue);

g_debugFilePtr = debugFilePtr;

		// compute pair distance with suppression
		fprintf(debugFilePtr, "Calculating the pair distsance with suppression (final:%d, proc:%d).....\n", finalEqClass->noOfEqClass, proEqClass->noOfEqClass);
		printf("Calculating the pair distsance with suppression (final:%d, proc:%d).....\n", finalEqClass->noOfEqClass, proEqClass->noOfEqClass);
		kDist_calculatePairDistanceWithSuppression(hash, distStorage, finalEqClass, proEqClass, genAllTable, conf);

		// printing
		fprintf(debugFilePtr, "Starting.....\n");
		printf("Starting.....\n");
//printDistStorage(debugFilePtr, distStorage);
//		fprintf(debugFilePtr, "############## proEqClass ##################\n");
//		printf("############## proEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//		printf("############## finalEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

		noOfRemain = proEqClass->noOfEqClass;
		iterationNo = 0;
		while (noOfRemain > 0)
		{
			iterationNo++;
			printf("Iteration no %d\n", iterationNo);

			
//{// find the distEntry (id, id2) in hash
//DistEntry *distEntry;
//distEntry = kDist_findDistEntry(hash, 0, 3);
//}


//printf("~~~~~~~~~~~1\n");
			// special case handle for the last one
			if (noOfRemain == 1)
			{
				//prevNoOfFinalEqClass = finalEqClass->noOfEqClass;
				//removeLastOne(proEqClass, conf, finalEqClass, &noOfPotentialTrunk);
				//listOfPotentialTrunk = NULL;

				// generalized one
				id = proEqClass->eqClass[0]->id;

				kDist_suppressBatch(hash, distStorage, id, finalEqClass, proEqClass, genAllTable, conf);

//fprintf(debugFilePtr, "  $$$$$$$$$ After Suppression $$$$$$$$$$$$$$$4\n");
//fprintf(debugFilePtr, "Printing Dist Storage...\n");
//printf("  $$$$$$$$$ After suppression $$$$$$$$$$$$$$$4\n");
//printf("Printing Dist Storage...\n");
//printDistStorage(debugFilePtr, distStorage);


			}
			else
			{
//printf("~~~~~~~~~~~1.1\n");
				// find and remove all precise alpha-deassociatedTrunks
				//prevNoOfFinalEqClass = finalEqClass->noOfEqClass;
//printf("~~~~~~~~~~~1.2\n");
				//listOfPotentialTrunk = removePreciseAlphaTrunk(proEqClass, conf, finalEqClass, &noOfPotentialTrunk);
//printf("~~~~~~~~~~~1.3\n");

//exit(0);
				// generalize the closest pair
				//fprintf(debugFilePtr, "  $$$$$$$$$ Generalizing $$$$$$$$$$$$$$$4\n");
				//printf("  $$$$$$$$$ Generalizing $$$$$$$$$$$$$$$4\n");
				//void kDist_findMinDistForGeneralization(DistStorage *distStorage, Hash *hash, generalizedAllTable *genAllTable, configure *conf, equivalenceClass *proEqClass, equivalenceClass *finalEqClass)
				kDist_findMinDistForGeneralization(distStorage, hash, genAllTable, conf, proEqClass, finalEqClass);

				//fprintf(debugFilePtr, "  $$$$$$$$$ After Generalization $$$$$$$$$$$$$$$4\n");
				//fprintf(debugFilePtr, "Printing Dist Storage...\n");
				//printf("  $$$$$$$$$ After Generalization $$$$$$$$$$$$$$$4\n");
//printf("Printing Dist Storage...\n");
//printDistStorage(debugFilePtr, distStorage);
//exit(0);
				// suppress the outlier
				//void kDist_suppressIteration(Hash *hash, DistStorage *distStorage, equivalenceClass *proEqClass, equivalenceClass *finalEqClass, configure *conf, generalizedAllTable *genAllTable)
				kDist_suppressIteration(hash, distStorage, proEqClass, finalEqClass, conf, genAllTable);

//fprintf(debugFilePtr, "  $$$$$$$$$ After Suppression $$$$$$$$$$$$$$$4\n");
//fprintf(debugFilePtr, "Printing Dist Storage...\n");
//printf("  $$$$$$$$$ After suppression $$$$$$$$$$$$$$$4\n");
//printf("Printing Dist Storage...\n");
//printDistStorage(debugFilePtr, distStorage);
//exit(0);
			}

			// print eq. class
			//fprintf(debugFilePtr, "After Generalizing.....\n");
			//printf("After Generalizing.....\n");
			//fprintf(debugFilePtr, "############## proEqClass ##################\n");
			//printf("############## proEqClass ##################\n");
			//printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
			//fprintf(debugFilePtr, "############## finalEqClass ##################\n");
			//printf("############## finalEqClass ##################\n");
			//printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

			
//printf("~~~~~~~~~~~2\n");

			noOfRemain = proEqClass->noOfEqClass;
		}

		
	}

#ifndef _WIN32
	getrusage(RUSAGE_SELF, &myTime2);	
#endif

	printf("Calculating the distortion...\n");
	fprintf(debugFilePtr, "Calculating the distortion...\n");
	//double calculateDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable)
	distortion = (double) calculateDistortion(finalEqClass, conf, genAllTable);
	printf("Distortion: %.4f\n", distortion);
	fprintf(debugFilePtr, "Distortion: %.4f\n", distortion);
	

#ifndef _WIN32
	userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
	sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

	printf("User time : %f seconds\n",userTime);
	printf("System time : %f seconds\n\n",sysTime);

	fprintf(debugFilePtr, "Execution Time\n");
	fprintf(debugFilePtr, "--------------\n");
	fprintf(debugFilePtr, "User time : %f seconds\n",userTime);
    fprintf(debugFilePtr, "System time : %f seconds\n\n",sysTime);
#endif

	fclose(debugFilePtr);
}



void randomMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable)
{
	FILE *debugFilePtr;

	int isAlphaK;

	summary *synopsis;
	equivalenceClass *proEqClass;
	equivalenceClass *finalEqClass;

	//int noOfGreatestPossRemovalCount;

	//int *listOfPotentialTrunk;
	//int noOfPotentialTrunk;

	//int prevNoOfFinalEqClass;

	int noOfRemain;

	//int bestAttrNo;

	int iterationNo;

	double distortion;

	//Hash *hash;
	//DistStorage *distStorage;
	int noOfSlot;
	float delta;

	float maxValue;

	int id;

#ifndef _WIN32
	float  userTime, sysTime;
	struct rusage myTime1, myTime2;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	if (conf->noOfTuple > 200)
	{
		noOfSlot = ((conf->noOfTuple*conf->noOfTuple)/200)-1;
	}
	else
	{
		noOfSlot = 5;
	}
	delta = 5.0f;

	maxValue = (float) (conf->noOfDim*2)*conf->noOfTuple/conf->K;

	debugFilePtr = (FILE *) fopen("debug.txt", "w");
	g_debugFilePtr = debugFilePtr;

	printf("Random Algorithm....\n");

	// preprocessing
	//printf("Preprocessing....\n");
	//prepProcessDataSet(dataSet, conf->K, genAllTable);

	// create summary
	printf("Creating Summary....\n");
	synopsis = createSummary(dataSet);

	// printing
	fprintf(debugFilePtr, "############## Summary ##################\n");
	printf("############## Summary ##################\n");
//	printSummary(debugFilePtr, synopsis, conf->noOfDim);

	// check whether it is alphaK
	//isAlphaK = isAlphaKAnonymity(dataSet, synopsis, conf);
	isAlphaK = 1;

	// 
	if (isAlphaK == 0)
	{
		printf("This data set cannot satisfy the alpha K anonymity!\n");
		exit(0);
	}
	else
	{
		// continue

		// generate equivalence class
		proEqClass = generateEquivalenceClass(dataSet, synopsis, conf); 

		// generate an empty equivalence class
		finalEqClass = new_equivalenceClass();

		// print eq. class
//		fprintf(debugFilePtr, "############## proEqClass ##################\n");
//		printf("############## proEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//		printf("############## finalEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

		// move the satisfied
		kDist_moveSatisfiedEqClass(proEqClass, finalEqClass, conf->K);

		// print eq. class
//		fprintf(debugFilePtr, "############## proEqClass ##################\n");
//		printf("############## proEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//		printf("############## finalEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);


		// printing
		fprintf(debugFilePtr, "Starting.....\n");
		printf("Starting.....\n");
//printDistStorage(debugFilePtr, distStorage);
//		fprintf(debugFilePtr, "############## proEqClass ##################\n");
//		printf("############## proEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//		printf("############## finalEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

		noOfRemain = proEqClass->noOfEqClass;
		iterationNo = 0;
		while (noOfRemain > 0)
		{
			iterationNo++;
			if (iterationNo%100 == 0)
			{
				printf("Iteration no %d\n", iterationNo);
			}

			
//{// find the distEntry (id, id2) in hash
//DistEntry *distEntry;
//distEntry = kDist_findDistEntry(hash, 0, 3);
//}


//printf("~~~~~~~~~~~1\n");
			// special case handle for the last one
			if (noOfRemain == 1)
			{
				//prevNoOfFinalEqClass = finalEqClass->noOfEqClass;
				//removeLastOne(proEqClass, conf, finalEqClass, &noOfPotentialTrunk);
				//listOfPotentialTrunk = NULL;

				// generalized one
				id = proEqClass->eqClass[0]->id;

				//kDist_suppressBatch(hash, distStorage, id, finalEqClass, proEqClass, genAllTable, conf);
				kDist_suppressBatchRandom(id, finalEqClass, proEqClass, genAllTable, conf);

//fprintf(debugFilePtr, "  $$$$$$$$$ After Suppression $$$$$$$$$$$$$$$4\n");
//fprintf(debugFilePtr, "Printing Dist Storage...\n");
//printf("  $$$$$$$$$ After suppression $$$$$$$$$$$$$$$4\n");
//printf("Printing Dist Storage...\n");
//printDistStorage(debugFilePtr, distStorage);


			}
			else
			{
				kDist_randomGeneralization(genAllTable, conf, proEqClass, finalEqClass);
			}

			// print eq. class
//			fprintf(debugFilePtr, "After Generalizing.....\n");
//			printf("After Generalizing.....\n");
//			fprintf(debugFilePtr, "############## proEqClass ##################\n");
//			printf("############## proEqClass ##################\n");
//			printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//			fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//			printf("############## finalEqClass ##################\n");
//			printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

			
//printf("~~~~~~~~~~~2\n");

			noOfRemain = proEqClass->noOfEqClass;
		}

		
	}

#ifndef _WIN32
	getrusage(RUSAGE_SELF, &myTime2);	
#endif

	printf("Calculating the distortion...\n");
	fprintf(debugFilePtr, "Calculating the distortion...\n");
	//double calculateDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable)
	distortion = (double) calculateDistortion(finalEqClass, conf, genAllTable);
	printf("Distortion: %.4f\n", distortion);
	fprintf(debugFilePtr, "Distortion: %.4f\n", distortion);
	

#ifndef _WIN32
	userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
	sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

	printf("User time : %f seconds\n",userTime);
	printf("System time : %f seconds\n\n",sysTime);

	fprintf(debugFilePtr, "Execution Time\n");
	fprintf(debugFilePtr, "--------------\n");
	fprintf(debugFilePtr, "User time : %f seconds\n",userTime);
    fprintf(debugFilePtr, "System time : %f seconds\n\n",sysTime);
#endif

	fclose(debugFilePtr);
}



equivalenceClass *fullSpace_KAlphaAnonymity(data *dataSet, configure *conf, generalizedAllTable *genAllTable, FILE *g_debugFilePtr)
{
	//FILE *debugFilePtr;

	int isAlphaK;

	summary *synopsis;
	equivalenceClass *proEqClass;
	equivalenceClass *finalEqClass;

	//double distortion;

	double *dist;

	//Hash *hash;
	//DistStorage *distStorage;
	int noOfSlot;
	float delta;

	float maxValue;

	int noOfDim;
	int *noOfLevel;
	
	AllGeneralizationDomainSet *currAllGenDomainSet;
	AllGeneralizationDomainSet *newAllGenDomainSet;

	//int id;

	int isCalculate;

	int i;

#ifndef _WIN32
	float  userTime, sysTime;
	struct rusage myTime1, myTime2;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	if (conf->noOfTuple > 200)
	{
		noOfSlot = ((conf->noOfTuple*conf->noOfTuple)/200)-1;
	}
	else
	{
		noOfSlot = 5;
	}
	delta = 5.0f;

	maxValue = (float) (conf->noOfDim*2)*conf->noOfTuple/conf->K;

	//debugFilePtr = (FILE *) fopen("debug.txt", "w");
	//g_debugFilePtr = debugFilePtr;

	printf("Random Algorithm....\n");

	// preprocessing
	//printf("Preprocessing....\n");
	//prepProcessDataSet(dataSet, conf->K, genAllTable);

	// create summary
	printf("Creating Summary....\n");
	synopsis = createSummary(dataSet);

	// printing
	//fprintf(debugFilePtr, "############## Summary ##################\n");
	//printf("############## Summary ##################\n");
//	printSummary(debugFilePtr, synopsis, conf->noOfDim);

	// check whether it is alphaK
	//isAlphaK = isAlphaKAnonymity(dataSet, synopsis, conf);
	isAlphaK = 1;

	// 
	if (isAlphaK == 0)
	{
		printf("This data set cannot satisfy the alpha K anonymity!\n");
		exit(0);
	}
	else
	{
		// continue

		// generate equivalence class
		proEqClass = generateEquivalenceClass(dataSet, synopsis, conf); 

		// generate an empty equivalence class
		//finalEqClass = new_equivalenceClass();

		// print eq. class
//		fprintf(debugFilePtr, "############## proEqClass ##################\n");
//		printf("############## proEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//		printf("############## finalEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);



		// printing
		//fprintf(debugFilePtr, "Starting.....\n");
		//printf("Starting.....\n");
//printDistStorage(debugFilePtr, distStorage);
//		fprintf(debugFilePtr, "############## proEqClass ##################\n");
//		printf("############## proEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//		printf("############## finalEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

		// for noOfLevel
		noOfDim = conf->noOfDim-1;
		noOfLevel = (int *) malloc(sizeof(int)*noOfDim);
		for (i = 0; i < noOfDim; i++)
		{
			noOfLevel[i] = genAllTable->genDimTable[i].noOfLevel;
		}


		// generate the single dimension
		currAllGenDomainSet = generateSingleDimension(noOfDim, noOfLevel);

		// do sth (currAllGenDomainSet)
		isCalculate = 0;
		dist = checkAllGenDomainSet(currAllGenDomainSet, proEqClass, conf, dataSet, genAllTable, isCalculate);

		//printf("Printing currAllGenDomainSet...\n");
		//print_AllGeneralizationDomainSet(debugFilePtr, currAllGenDomainSet);

		// testing
		//for (i = 0; i < 1000; i++)
		//{
		//	printf(" Processing Dimensions Size %d...\n", i);
		//	fprintf(debugFilePtr, " Processing Dimensions Size %d...\n", i);

			// generate larger dimension
		//	newAllGenDomainSet = generateLargerDimension(currAllGenDomainSet);

			// check
		//	isCalculate = 0;
		//	dist = checkAllGenDomainSet(currAllGenDomainSet, proEqClass, conf, dataSet, genAllTable, isCalculate);

			// free the newAllGenDomainSet
		//	free_AllGeneralizationDomainSet(newAllGenDomainSet);
		//	free(newAllGenDomainSet);
		//}

		for (i = 1; i < conf->noOfDim-1; i++)
		{
			//printf(" Processing Dimensions Size %d...\n", i);
			//fprintf(debugFilePtr, " Processing Dimensions Size %d...\n", i);
			// generate larger dimensin
			//AllGeneralizationDomainSet *generateLargerDimension(AllGeneralizationDomainSet *allGenDomainSet);
			newAllGenDomainSet = generateLargerDimension(currAllGenDomainSet);

			// free the currAllGenDomainSet
			free_AllGeneralizationDomainSet(currAllGenDomainSet);
			free(currAllGenDomainSet);

			//
			currAllGenDomainSet = newAllGenDomainSet;

			// do sth (currAllGenDomainSet)
			if (i == conf->noOfDim-2)
			{
				isCalculate = 1;
			}
			else
			{
				isCalculate = 0;
			}
			dist = checkAllGenDomainSet(currAllGenDomainSet, proEqClass, conf, dataSet, genAllTable, isCalculate);

			//printf("Printing currAllGenDomainSet...\n");
			//print_AllGeneralizationDomainSet(debugFilePtr, currAllGenDomainSet);
		}

		// final step (to finalEqClass)
		if (dist == NULL)
		{
			printf(" The Last iteration has something wrong!\n");
		}
		else
		{
			//finalEqClass = chooseBestFinalEqClass(currAllGenDomainSet, dist);
			finalEqClass = chooseBestFinalEqClass(currAllGenDomainSet, dist, proEqClass, dataSet, conf, genAllTable);
		}
	}

	return finalEqClass;
}


equivalenceClass *fullSpace_TCloseness(data *dataSet, configure *conf, generalizedAllTable *genAllTable, FILE *g_debugFilePtr)
{
	//FILE *debugFilePtr;

	int isAlphaK;

	summary *synopsis;
	equivalenceClass *proEqClass;
	equivalenceClass *finalEqClass;

	//double distortion;

	double *dist;

	//Hash *hash;
	//DistStorage *distStorage;
	int noOfSlot;
	float delta;

	float maxValue;

	int noOfDim;
	int *noOfLevel;
	
	AllGeneralizationDomainSet *currAllGenDomainSet;
	AllGeneralizationDomainSet *newAllGenDomainSet;

	//int id;

	int isCalculate;

	int *globalDist;
	double threshold;

	int i;

#ifndef _WIN32
	float  userTime, sysTime;
	struct rusage myTime1, myTime2;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	if (conf->noOfTuple > 200)
	{
		noOfSlot = ((conf->noOfTuple*conf->noOfTuple)/200)-1;
	}
	else
	{
		noOfSlot = 5;
	}
	delta = 5.0f;

	maxValue = (float) (conf->noOfDim*2)*conf->noOfTuple/conf->K;

	//debugFilePtr = (FILE *) fopen("debug.txt", "w");
	//g_debugFilePtr = debugFilePtr;

	printf("Random Algorithm....\n");

	// preprocessing
	//printf("Preprocessing....\n");
	//prepProcessDataSet(dataSet, conf->K, genAllTable);

	// create summary
	printf("Creating Summary....\n");
	synopsis = createSummary(dataSet);

	// printing
	//fprintf(debugFilePtr, "############## Summary ##################\n");
	//printf("############## Summary ##################\n");
//	printSummary(debugFilePtr, synopsis, conf->noOfDim);

	// check whether it is alphaK
	//isAlphaK = isAlphaKAnonymity(dataSet, synopsis, conf);
	isAlphaK = 1;

	// 
	if (isAlphaK == 0)
	{
		printf("This data set cannot satisfy the alpha K anonymity!\n");
		exit(0);
	}
	else
	{
		// continue
		globalDist = tclose_getWholeDist(dataSet);
		threshold = conf->tThreshold;

		// generate equivalence class
		proEqClass = generateEquivalenceClass(dataSet, synopsis, conf); 

		// generate an empty equivalence class
		//finalEqClass = new_equivalenceClass();

		// print eq. class
//		fprintf(debugFilePtr, "############## proEqClass ##################\n");
//		printf("############## proEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//		printf("############## finalEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);



		// printing
		//fprintf(debugFilePtr, "Starting.....\n");
		//printf("Starting.....\n");
//printDistStorage(debugFilePtr, distStorage);
//		fprintf(debugFilePtr, "############## proEqClass ##################\n");
//		printf("############## proEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
//		fprintf(debugFilePtr, "############## finalEqClass ##################\n");
//		printf("############## finalEqClass ##################\n");
//		printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

		// for noOfLevel
		noOfDim = conf->noOfDim-1;
		noOfLevel = (int *) malloc(sizeof(int)*noOfDim);
		for (i = 0; i < noOfDim; i++)
		{
			noOfLevel[i] = genAllTable->genDimTable[i].noOfLevel;
		}


		// generate the single dimension
		currAllGenDomainSet = generateSingleDimension(noOfDim, noOfLevel);

		// do sth (currAllGenDomainSet)
		isCalculate = 0;
		dist = checkAllGenDomainSet_TCloseness(threshold, globalDist, currAllGenDomainSet, proEqClass, conf, dataSet, genAllTable, isCalculate);

		//printf("Printing currAllGenDomainSet...\n");
		//print_AllGeneralizationDomainSet(debugFilePtr, currAllGenDomainSet);

		// testing
		//for (i = 0; i < 1000; i++)
		//{
		//	printf(" Processing Dimensions Size %d...\n", i);
		//	fprintf(debugFilePtr, " Processing Dimensions Size %d...\n", i);

			// generate larger dimension
		//	newAllGenDomainSet = generateLargerDimension(currAllGenDomainSet);

			// check
		//	isCalculate = 0;
		//	dist = checkAllGenDomainSet(currAllGenDomainSet, proEqClass, conf, dataSet, genAllTable, isCalculate);

			// free the newAllGenDomainSet
		//	free_AllGeneralizationDomainSet(newAllGenDomainSet);
		//	free(newAllGenDomainSet);
		//}

		for (i = 1; i < conf->noOfDim-1; i++)
		{
			//printf(" Processing Dimensions Size %d...\n", i);
			//fprintf(debugFilePtr, " Processing Dimensions Size %d...\n", i);
			// generate larger dimensin
			//AllGeneralizationDomainSet *generateLargerDimension(AllGeneralizationDomainSet *allGenDomainSet);
			newAllGenDomainSet = generateLargerDimension(currAllGenDomainSet);

			// free the currAllGenDomainSet
			free_AllGeneralizationDomainSet(currAllGenDomainSet);
			free(currAllGenDomainSet);

			//
			currAllGenDomainSet = newAllGenDomainSet;

			// do sth (currAllGenDomainSet)
			if (i == conf->noOfDim-2)
			{
				isCalculate = 1;
			}
			else
			{
				isCalculate = 0;
			}
			dist = checkAllGenDomainSet_TCloseness(threshold, globalDist, currAllGenDomainSet, proEqClass, conf, dataSet, genAllTable, isCalculate);

			//printf("Printing currAllGenDomainSet...\n");
			//print_AllGeneralizationDomainSet(debugFilePtr, currAllGenDomainSet);
		}

		// final step (to finalEqClass)
		if (dist == NULL)
		{
			printf(" The Last iteration has something wrong!\n");
		}
		else
		{
			//finalEqClass = chooseBestFinalEqClass(currAllGenDomainSet, dist);
			finalEqClass = chooseBestFinalEqClass(currAllGenDomainSet, dist, proEqClass, dataSet, conf, genAllTable);
		}
	}

	return finalEqClass;
}




void fullSpaceMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable)
{
	FILE *debugFilePtr;

	//int isAlphaK;

	//summary *synopsis;
	//equivalenceClass *proEqClass;
	equivalenceClass *finalEqClass;

	//int noOfGreatestPossRemovalCount;

	//int *listOfPotentialTrunk;
	//int noOfPotentialTrunk;

	//int prevNoOfFinalEqClass;

	//int noOfRemain;

	//int bestAttrNo;

	//int iterationNo;

	double distortion;

	//double *dist;

	//Hash *hash;
	//DistStorage *distStorage;
	int noOfSlot;
	float delta;

	float maxValue;

	//int noOfDim;
	//int *noOfLevel;
	
	//AllGeneralizationDomainSet *currAllGenDomainSet;
	//AllGeneralizationDomainSet *newAllGenDomainSet;

	//int id;

	//int isCalculate;

	//int i;

#ifndef _WIN32
	float  userTime, sysTime;
	struct rusage myTime1, myTime2;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	if (conf->noOfTuple > 200)
	{
		noOfSlot = ((conf->noOfTuple*conf->noOfTuple)/200)-1;
	}
	else
	{
		noOfSlot = 5;
	}
	delta = 5.0f;

	maxValue = (float) (conf->noOfDim*2)*conf->noOfTuple/conf->K;

	debugFilePtr = (FILE *) fopen("debug.txt", "w");
	g_debugFilePtr = debugFilePtr;

	finalEqClass = fullSpace_KAlphaAnonymity(dataSet, conf, genAllTable, g_debugFilePtr);

	if (finalEqClass == NULL)
	{
		printf(" finalEqClass is NULL!\n");
		fprintf(debugFilePtr, " finalEqClass is NULL!\n");
		exit(0);
	}

#ifndef _WIN32
	getrusage(RUSAGE_SELF, &myTime2);	
#endif

	printf("Calculating the distortion...\n");
	fprintf(debugFilePtr, "Calculating the distortion...\n");
	//double calculateDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable)
	distortion = (double) calculateDistortion(finalEqClass, conf, genAllTable);
	printf("Distortion: %.4f\n", distortion);
	fprintf(debugFilePtr, "Distortion: %.4f\n", distortion);
	

#ifndef _WIN32
	userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
	sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

	printf("User time : %f seconds\n",userTime);
	printf("System time : %f seconds\n\n",sysTime);

	fprintf(debugFilePtr, "Execution Time\n");
	fprintf(debugFilePtr, "--------------\n");
	fprintf(debugFilePtr, "User time : %f seconds\n",userTime);
    fprintf(debugFilePtr, "System time : %f seconds\n\n",sysTime);
#endif

	fclose(debugFilePtr);
}



equivalenceClass *topDownAlpha_KAlphaAnonymity(data *dataSet, configure *conf, generalizedAllTable *genAllTable, FILE *g_debugFilePtr)
{
	FILE *debugFilePtr;

	int isAlphaK;

	summary *synopsis;
	equivalenceClass *proEqClass;
	equivalenceClass *finalEqClass;

	//int noOfGreatestPossRemovalCount;

	//int *listOfPotentialTrunk;
	//int noOfPotentialTrunk;

	//int prevNoOfFinalEqClass;

	//int noOfRemain;

	//int bestAttrNo;

	int iterationNo;

	//double distortion;

	//double *dist;

	//Hash *hash;
	//DistStorage *distStorage;
	int noOfSlot;
	float delta;

	float maxValue;

	int noOfDim;
	//int *noOfLevel;
	
	//AllGeneralizationDomainSet *currAllGenDomainSet;
	//AllGeneralizationDomainSet *newAllGenDomainSet;

	int **noOfChild;
	int ***isSatisfy;
	equivalenceTuple ****childEqTuple;
	equivalenceTuple ***parentEqTuple;

	equivalenceTuple **proEqTuple;
	//int noOfEqClass;

	//int noOfProEqTuple;
	//int id;

	//int isCalculate;

	int noOfParent;
	//equivalenceTuple *tempEqTuple;

	int i, j; //, k;

#ifndef _WIN32
	float  userTime, sysTime;
	struct rusage myTime1, myTime2;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	debugFilePtr = g_debugFilePtr;

	if (conf->noOfTuple > 200)
	{
		noOfSlot = ((conf->noOfTuple*conf->noOfTuple)/200)-1;
	}
	else
	{
		noOfSlot = 5;
	}
	delta = 5.0f;

	maxValue = (float) (conf->noOfDim*2)*conf->noOfTuple/conf->K;


	//printf("Random Algorithm....\n");

	// preprocessing
	//printf("Preprocessing....\n");
	//prepProcessDataSet(dataSet, conf->K, genAllTable);

	// create summary
	//printf("Creating Summary....\n");
	synopsis = createSummary(dataSet);

	// printing
	//fprintf(debugFilePtr, "############## Summary ##################\n");
	//printf("############## Summary ##################\n");
	//printSummary(debugFilePtr, synopsis, conf->noOfDim);

	// check whether it is alphaK
	//isAlphaK = isAlphaKAnonymity(dataSet, synopsis, conf);
	isAlphaK = 1;

	// 
	if (isAlphaK == 0)
	{
		printf("This data set cannot satisfy the alpha K anonymity!\n");
		exit(0);
	}
	else
	{
		// continue

		// generate equivalence class
		//proEqClass = generateEquivalenceClass(dataSet, synopsis, conf); 

		// generalize to the top level
		proEqClass = top_generalize2TopLevel(dataSet, genAllTable, conf);

		// generate an empty equivalence class
		finalEqClass = new_equivalenceClass();

		// print eq. class
		//fprintf(debugFilePtr, "############## proEqClass ##################\n");
		//printf("############## proEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
		//fprintf(debugFilePtr, "############## finalEqClass ##################\n");
		//printf("############## finalEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);



		// printing
		//fprintf(debugFilePtr, "Starting.....\n");
		//printf("Starting.....\n");
//printDistStorage(debugFilePtr, distStorage);
		//fprintf(debugFilePtr, "############## proEqClass ##################\n");
		//printf("############## proEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
		//fprintf(debugFilePtr, "############## finalEqClass ##################\n");
		//printf("############## finalEqClass ##################\n");
		//printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);


		iterationNo = 0;
		while (proEqClass->noOfEqClass > 0)
		{
			//printf(" Iteration No %d\n", iterationNo);
			iterationNo++;
			// generate the parent (cloning)
			noOfParent = proEqClass->noOfEqClass;
			proEqTuple = proEqClass->eqClass;

			noOfDim = conf->noOfDim-1;
			parentEqTuple = (equivalenceTuple ***) malloc(sizeof(equivalenceTuple **)*noOfParent);
			for (i = 0; i < noOfParent; i++)
			{
				parentEqTuple[i] = (equivalenceTuple **) malloc(sizeof(equivalenceTuple *)*noOfDim);
				for (j = 0; j < noOfDim; j++)
				{
					parentEqTuple[i][j] = cloneEquivalenceTuple(proEqTuple[i], conf);
				}
			}

			// free proEqClass
			proEqClass->noOfEqClass = 0;
			freeEquivalenceClass(proEqClass);
			
			childEqTuple = top_generateAllExpandValidEqTuple(parentEqTuple, noOfParent, conf, dataSet, genAllTable, &noOfChild, &isSatisfy);

			// print
			//printf(" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~   childEqTuple ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
			//fprintf(debugFilePtr, " ~~~~~~~~~~~~~~~~~~~~~~~~~~~~   childEqTuple ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
			//for (i = 0; i < noOfParent; i++)
			//{
			//	printf("  Parent %d --------------------------------------------\n", i);
			//	fprintf(debugFilePtr, "  Parent %d --------------------------------------------\n", i);
				
			//	for (j = 0; j < noOfDim; j++)
			//	{
			//		printf("     Dim %d ----------------------\n", j);
			//		printf("     !!! Parent %d-%d !!! \n", i, j);
			//		fprintf(debugFilePtr, "     Dim %d ----------------------\n", j);
			//		fprintf(debugFilePtr, "     !!! Parent %d-%d !!! \n", i, j);
			//		printEquivalenceTuple(debugFilePtr, parentEqTuple[i][j], noOfDim+1);
			//		for (k = 0; k < noOfChild[i][j]; k++)
			//		{
			//			printf("       Child %d. \n", k);
			//			fprintf(debugFilePtr, "       Child %d. \n", k);
			//			printEquivalenceTuple(debugFilePtr, childEqTuple[i][j][k], noOfDim+1);
			//		}
			//	}
			//}

			
			top_processBestAttribute(finalEqClass, proEqClass, noOfParent, parentEqTuple, childEqTuple, noOfChild, isSatisfy, conf);

			// printing
			//fprintf(debugFilePtr, "############## proEqClass ##################\n");
			//printf("############## proEqClass ##################\n");
			//printEquivalenceClass(debugFilePtr, proEqClass, conf->noOfDim);
			//fprintf(debugFilePtr, "############## finalEqClass ##################\n");
			//printf("############## finalEqClass ##################\n");
			//printEquivalenceClass(debugFilePtr, finalEqClass, conf->noOfDim);

			//free
			free(parentEqTuple);
			free(childEqTuple);
			free(noOfChild);
			free(isSatisfy);
		}

	}

	return finalEqClass;

}


void topDownAlphaMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable)
{
	FILE *debugFilePtr;

	equivalenceClass *finalEqClass;

	double distortion;

	int noOfSlot;
	float delta;

	float maxValue;


#ifndef _WIN32
	float  userTime, sysTime;
	struct rusage myTime1, myTime2;

	getrusage(RUSAGE_SELF,&myTime1);
#endif

	if (conf->noOfTuple > 200)
	{
		noOfSlot = ((conf->noOfTuple*conf->noOfTuple)/200)-1;
	}
	else
	{
		noOfSlot = 5;
	}
	delta = 5.0f;

	maxValue = (float) (conf->noOfDim*2)*conf->noOfTuple/conf->K;

	debugFilePtr = (FILE *) fopen("debug.txt", "w");
	g_debugFilePtr = debugFilePtr;

	finalEqClass = topDownAlpha_KAlphaAnonymity(dataSet, conf, genAllTable, g_debugFilePtr);

	if (finalEqClass == NULL)
	{
		printf(" finalEqClass is NULL!\n");
		fprintf(debugFilePtr, " finalEqClass is NULL!\n");
		exit(0);
	}

#ifndef _WIN32
	getrusage(RUSAGE_SELF, &myTime2);	
#endif

	printf("Calculating the distortion...\n");
	fprintf(debugFilePtr, "Calculating the distortion...\n");
	//double calculateDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable)
	distortion = (double) calculateDistortion(finalEqClass, conf, genAllTable);
	printf("Distortion: %.4f\n", distortion);
	fprintf(debugFilePtr, "Distortion: %.4f\n", distortion);

	printf("Calculating the sen distortion...\n");
	fprintf(debugFilePtr, "Calculating the sen distortion...\n");
	//double calculateDistortion(equivalenceClass *eqClass, configure *config, generalizedAllTable *genAllTable)
	distortion = (double) calculateSenDistortion(finalEqClass, conf, genAllTable);
	printf("Sen Distortion: %.4f\n", distortion);
	fprintf(debugFilePtr, "Sen Distortion: %.4f\n", distortion);
	

#ifndef _WIN32
	userTime =
     		((float) (myTime2.ru_utime.tv_sec  - myTime1.ru_utime.tv_sec)) +
       		((float) (myTime2.ru_utime.tv_usec - myTime1.ru_utime.tv_usec)) * 1e-6;
	sysTime =
       		((float) (myTime2.ru_stime.tv_sec  - myTime1.ru_stime.tv_sec)) +
       		((float) (myTime2.ru_stime.tv_usec - myTime1.ru_stime.tv_usec)) * 1e-6;

	printf("User time : %f seconds\n",userTime);
	printf("System time : %f seconds\n\n",sysTime);

	fprintf(debugFilePtr, "Execution Time\n");
	fprintf(debugFilePtr, "--------------\n");
	fprintf(debugFilePtr, "User time : %f seconds\n",userTime);
    fprintf(debugFilePtr, "System time : %f seconds\n\n",sysTime);
#endif

	fclose(debugFilePtr);
}






