
#ifndef INJECTOR_H
#define INJECTOR_H

#include <math.h>
#include "readData.h"
#include "set.h"
#include "equivalence.h"
#include "signature.h"
#include "mechDistortion.h"
#include "ass.h"
#include "anatomy.h"

struct assocRule_s
{
	int noOfX;
	dimension *X;
	int *dimNo;

	int Y;
};

typedef struct assocRule_s assocRule;

struct assocRuleTable_s
{
	int noOfRule;

	assocRule **ruleList;
};

typedef struct assocRuleTable_s assocRuleTable;

struct specialN_s
{
	int s;

	mySet **IVS;

	int *count;

	int noOfIVS;
};

typedef struct specialN_s specialN;

equivalenceClass *injector_main(data *aData, int l, configure *config);

int injector_MBM_findUnmatch_qid(int indexQID, int *matchQID, int *matchSen, int *member, dimension *senID, int *isChooseQID, int *isChooseSen, int noOfMember, mySet **IVSList, int length);

int injector_MBM_findUnmatch_sen(int indexQID, int indexSen, int *matchQID, int *matchSen, int *member, dimension *senID, int *isChooseQID, int *isChooseSen, int noOfMember, mySet **IVSList, int length);

int injector_MBM_findMatch_sen(int indexSen, int *matchQID, int *matchSen, int *member, dimension *senID, int *isChooseQID, int *isChooseSen, int noOfMember, mySet **IVSList, int length);

void injector_singleExecution(data *aData, int l, configure *config, generalizedAllTable *genAllTable);

#endif
