/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE innerprod_R(
PmR mu,
PmR mv
)
{
MAT_TYPE InnerProduct;

  if (mu->rows == 1         &&
      mu->cols == mv->rows  &&
      mv->cols == 1
     )
     {
      InnerProduct = innerprod_uDotv_uv(mu,mv);
     }
    else if
     (mu->rows == 1        &&
      mv->rows == 1        &&
      mu->cols == mv->cols
     )
     {
      InnerProduct = innerprod_uDotv_uvT(mu,mv);
     }
    else if
     (mu->rows == mv->rows &&
      mu->cols == mv->cols &&
      mu->cols == 1
     )
     {
      InnerProduct = innerprod_uDotv_vTu(mu,mv);
     }
    else if
     (mu->rows          == mv->cols &&
      mu->cols          == 1   &&
      mv->rows          == 1
     )
     {
      InnerProduct = innerprod_uDotv_vu(mu,mv);
     }
     else
     {
      printf(" innerprod_R() error.\n\n");

      printf("\nPress Return to continue\n");
      //getchar();
      //exit(1);
     }


  return(InnerProduct);
}



/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE normP2_R(
PmR mu
)
{
  return(innerprod_R(mu,mu));
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE norm_R(
PmR mu
)
{
  return( (MAT_TYPE) sqrt(innerprod_R(mu,mu)));
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE norm_mR(
PmR mu,
int ru
)
{
MAT_TYPE NormP2;

//MAT_TYPE pT[MXR][MXC]; 
//mR mT ={MXR,MXC,&pT[0][0]};
mR mT;

         mT.rows = 1;  mT.cols = mu->cols;
		 mT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mT.rows*mT.cols);

            copy_r_R(mu,ru, &mT,0);
            NormP2 = innerprod_R(&mT,&mT);
	free(mT.pb);

return( (MAT_TYPE) sqrt(NormP2));
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE norm_c_mR(
PmR mu,
int cu
)
{
MAT_TYPE NormP2;

//MAT_TYPE pT[MXR][MXC]; 
//mR mT ={MXR,MXC,&pT[0][0]};
mR mT;

         mT.rows = mu->rows;  mT.cols = 1;
		 mT.pb  = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mT.rows*mT.cols);

            copy_c_R(mu,cu, &mT,0);
            NormP2 = innerprod_R(&mT,&mT);

	free(mT.pb);

return( (MAT_TYPE) sqrt(NormP2));
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void normalize_c_mR(
PmR mu
)
{
MAT_TYPE Norm;
MAT_TYPE invNorm;
int n;
/* -------------------------------------------------------------------------- */
  for(n=0; n<mu->cols; n++)
     {
      Norm = norm_c_mR(mu,n);
      if(Norm)
      {
       invNorm =  (MAT_TYPE) 1./(Norm);
       mul_c_R(mu,n,invNorm);
      }
     }
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE distanceP2_R(
PmR mu,
PmR mv
)
{
MAT_TYPE DistanceP2;

//MAT_TYPE pu_mns_v [MXR][MXC];
//mR mu_mns_v={MXR, MXC,&pu_mns_v[0][0]};
mR mu_mns_v;

       mu_mns_v.rows = mu->rows;
       mu_mns_v.cols = mu->cols;
	    mu_mns_v.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mu->rows*mu->cols);

      sub_mR(mu,mv,&mu_mns_v);

  DistanceP2 = normP2_R(&mu_mns_v);

  free(mu_mns_v.pb);

  return(DistanceP2);
}


