/*         .h         freeware           http://groups.yahoo.com/group/mathc/ */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void Gram_Schimdt_mR(
PmR mu,
PmR mv)
{
int a;
int n;
int m;

//MAT_TYPE pbvT[MXR][MXC];
//mR mvT ={MXR,MXC,&pbvT[0][0]};
mR mvT;

   mvT.rows = 1;          mvT.cols = mu->cols;
   mvT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mvT.rows*mvT.cols);

     if(mu->rows > mu->cols)
    {
     printf("\n Gram_Schimdt_mR() error - ");
     printf("\n Press return to continue");
     //getchar();
     //exit(1);
    }

   a = mu->rows;
   copy_r_R(mu,0,mv,0);
   for(n=1 ; n<a; n++)
     for(m=0 ; m<n; m++)
      {
         if(!m){  copy_r_R(mu,n, mv,        n);}
               projwn_r_mR(mv,n, mv, m,&mvT,0);
                  sub_r_mR(mv,n,&mvT,0, mv,n);
       }

	free(mvT.pb);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void unitary_u_mR(
PmR u,
PmR mA
)
{
int c_A;
int i;
int j;

//MAT_TYPE pbAT  [MXR][MXC];
//mR mAT   ={MXR,MXC,&pbAT  [0][0]};
//MAT_TYPE pbAID [MXR][MXC];
//mR mAID  ={MXR,MXC,&pbAID [0][0]};
//MAT_TYPE pbAID2[MXR][MXC];
//mR mAID2 ={MXR,MXC,&pbAID2[0][0]};
//MAT_TYPE pbAIDT[MXR][MXC];
//mR mAIDT ={MXR,MXC,&pbAIDT[0][0]};

mR mAT;
mR mAID;
mR mAID2;
mR mAIDT;

         mAT.rows=mA->rows;   mAT.cols=mA->cols;
        mAID.rows=mA->rows;  mAID.cols=mA->cols+1;
       mAID2.rows=mA->rows; mAID2.cols=mA->cols+1;
       mAIDT.rows=mA->rows; mAIDT.cols=mA->cols+1;

	   mAT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mAT.rows*mAT.cols);
	   mAID.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mAID.rows*mAID.cols);
	   mAID2.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mAID2.rows*mAID2.cols);
	   mAIDT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mAIDT.rows*mAIDT.cols);
/* -------------------------------------------------------------------------- */
 normalize_c_mR(u);
       u_eye_mR(u,&mAID);
        copy_mR(&mAID,&mAID2);
        copy_mR(&mAID,&mAIDT);
 gaussjordan_mR(     &mAIDT);

 c_A=0;
 for (i=0; i<mAIDT.rows; i++)
 for (j=0; j<mAIDT.cols; j++)
    {
     if((*(mAIDT.pb+i *mAIDT.cols+j)))
       {
        copy_c_R(&mAID2,j,&mAT,c_A);
        c_A++;
        break;
       }
    }
     transpose_mR(&mAT,mA);
  Gram_Schimdt_mR(mA,&mAT);       /* Work on the rows, we want on the columns */
     transpose_mR(&mAT,mA);
   normalize_c_mR(mA);

   	   free(mAT.pb);
	   free(mAID.pb);
	   free(mAID2.pb);
	   free(mAIDT.pb);
}



/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void QR_mR(
PmR A,
PmR Q,
PmR R
)
{
int a;
int n;
int m;
MAT_TYPE Norm;

//MAT_TYPE pbQT [MXR][MXC];
//mR QT ={MXR,MXC,&pbQT   [0][0]};
//MAT_TYPE pbUT [MXR][MXC];
//mR UT ={MXR,MXC,&pbUT   [0][0]};

mR QT;
mR UT;

//MAT_TYPE pba_T[MXR][MXC];
//mR  A_T ={MXR,MXC,&pba_T[0][0]};
//MAT_TYPE pbQ_T[MXR][MXC];
//mR mQ_T ={MXR,MXC,&pbQ_T[0][0]};
//MAT_TYPE pbR_T[MXR][MXC];
//mR mR_T ={MXR,MXC,&pbR_T[0][0]};

mR A_T;
mR mQ_T;
mR mR_T;


    A_T.rows = A->cols;            A_T.cols = A->rows;
   mQ_T.rows = Q->cols;           mQ_T.cols = Q->rows;
   mR_T.rows = R->cols;           mR_T.cols = R->rows;

     QT.rows = 1;                   QT.cols = A->rows;
     UT.rows = 1;                   UT.cols = A->rows;

	 A_T.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*A_T.rows*A_T.cols);
	 mQ_T.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mQ_T.rows*mQ_T.cols);
	 mR_T.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*mR_T.rows*mR_T.cols);

	 QT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*QT.rows*QT.cols);
	 UT.pb = (MAT_TYPE *) malloc(sizeof(MAT_TYPE)*UT.rows*UT.cols);


  /*     if(A->rows > A->cols)
    {
     printf("\n QR_mR() error - ");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }     */

   transpose_mR(A,&A_T);

   a = A->rows;
   copy_r_R(&A_T,0,&mQ_T,0);
   for(n=1 ; n<a; n++)
     for(m=0 ; m<n; m++)
      {
         if(!m){  copy_r_R( &A_T,n, &mQ_T,         n);}
               projwn_r_mR(&mQ_T,n, &mQ_T, m,  &QT,0);
                  sub_r_mR(&mQ_T,n,   &QT, 0,&mQ_T,n);
       }


   for(n=0 ; n<a; n++)
     {
      Norm = norm_mR(&mQ_T,n);
      if(Norm) Norm =  (MAT_TYPE) (1./Norm);
      mul_r_R(&mQ_T,n,Norm);
     }


  for(n=0; n<A_T.rows; n++)
      {
       copy_r_R(&A_T,n, &UT,0);
       for(m=0; m<A_T.cols; m++)
         {
          copy_r_R(&mQ_T,m, &QT,0);
          *(mR_T.pb+n *mR_T.cols+m)  = innerprod_R(&UT,&QT);
         }
       }
   transpose_mR(&mQ_T,Q);
   transpose_mR(&mR_T,R);

	 free(A_T.pb);
	 free(mQ_T.pb);
	 free(mR_T.pb);

	 free(QT.pb);
	 free(UT.pb);
}


