/* xxnpoly.h          freeware           http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void mofpoly_mR(
PmR mpxy,
PmR mOut)
{
   int i;
   int j;
   int p;

  for (   i=0; i<mpxy->rows; i++)
   {
    p = mpxy->rows;
    for ( j = 0 ; j < mOut->cols-1; j++)
          *(mOut->pb+i *mOut->cols+j) =  (MAT_TYPE) pow(*(mpxy->pb+i *mpxy->cols),--p);
          *(mOut->pb+i *mOut->cols+j) =     *(mpxy->pb+i *mpxy->cols+1);
   }
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void polyresultis_mR(
PmR mOut)
{
int i;
int p = mOut->rows;

  printf("  y = ");
  for (   i = 0 ; i < mOut->rows    ; i++)
     printf(" %+.3fx**%d",*(mOut->pb+i *mOut->cols+mOut->cols-1),--p);
  printf("\n");
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void calculate_y_mR(
PmR mOut,
MAT_TYPE fpoint)
{
int i;
int p = mOut->rows;
MAT_TYPE fT;
MAT_TYPE fT2;

fT2 = 0;

  for (   i=0; i<mOut->rows; i++)
   {
    fT  =  (MAT_TYPE) ( *(mOut->pb+i *mOut->cols+mOut->cols-1) *  pow(fpoint,--p));
    fT2 = (fT2+fT);
   }
   printf(" With x =  %+.3f,       y = %+.3f \n",fpoint,fT2);
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gplt_polyresultis_mR(
   char filename[FILENAME],
PmR mOut)
{
FILE *fp;
 int i;
 int p = mOut->rows;

  fp = fopen(filename,"w");

  fprintf(fp,"\n");
  fprintf(fp,"  f(x) = ");
  for (   i = 0 ; i < mOut->rows    ; i++)
      fprintf(fp," %+.5f*x**%d",*(mOut->pb+i *mOut->cols+mOut->cols-1),--p);

   fprintf(fp,"  \n\n");
   fprintf(fp,"  plot f(x) with lines, \"points\" with points\n");
   fprintf(fp,"  reset\n");

   fclose(fp);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void p_poly_mR(
PmR v)
{
int i;
int p=0;

  printf("  y = ");

  for (i=0; i<v->rows; i++)
      {
       if(!p)        printf(" %+.3f",     *(v->pb+i *v->cols+v->cols-1));
       else if(p==1) printf(" %+.3fx",    *(v->pb+i *v->cols+v->cols-1));
       else          printf(" %+.3fx**%d",*(v->pb+i *v->cols+v->cols-1),p);
       p++;
      }
  printf("\n");
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gplt_p_poly_mR(
char filename[FILENAME],
PmR v)
{
FILE *fp;
int i;
int p=0;

  fp = fopen(filename,"w");

  fprintf(fp,"\n");
  fprintf(fp,"  f(x) = ");

  for (i=0; i<v->rows; i++)
      {
       if(!p)        fprintf(fp," %+.6f",      *(v->pb+i *v->cols+v->cols-1));
       else if(p==1) fprintf(fp," %+.6f*x",    *(v->pb+i *v->cols+v->cols-1));
       else          fprintf(fp," %+.6f*x**%d",*(v->pb+i *v->cols+v->cols-1),p);
       p++;
      }

   fprintf(fp,"\n\n");
   fprintf(fp,"  plot f(x) with lines, \"points\" with points\n");
   fprintf(fp,"  reset\n");

   fclose(fp);
}
