/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    : On a complexZ.                                                     */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ gfpivot_Z(
PmZ     m,
int      rowpivot,
int      colpivot,
int      colp,
int      rown_mns
)
{
complexZ f;

complexZ fn;
complexZ fn_mns;

complexZ fp;
complexZ fpivot;

  fpivot.r =  (*(m->pb+rowpivot  *m->cols+colpivot*C2   ));
  fpivot.i =  (*(m->pb+rowpivot  *m->cols+colpivot*C2+C1));

      fp.r =  (*(m->pb+rowpivot  *m->cols+colp*C2   ));
      fp.i =  (*(m->pb+rowpivot  *m->cols+colp*C2+C1));

   fn_mns.r = -(*(m->pb+rown_mns *m->cols+colpivot*C2   ));
   fn_mns.i = -(*(m->pb+rown_mns *m->cols+colpivot*C2+C1));

      fn.r =  (*(m->pb+rown_mns  *m->cols+colp*C2   ));
      fn.i =  (*(m->pb+rown_mns  *m->cols+colp*C2+C1));

  if(fn_mns.r || fn_mns.i)
     {
      f = add_Z( mul_Z(fpivot,fn), mul_Z(fp,fn_mns));
     }
  else
     {
      f.r =  (*(m->pb+rown_mns  *m->cols+colp*C2   ));
      f.i =  (*(m->pb+rown_mns  *m->cols+colp*C2+C1));
     }

 return(f);
}




/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  On a row.                                                         */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void grpivot_mZ(
PmZ  m,
int      rowpivot,
int      colpivot,
int      rown_mns
)
{
     int colp;
complexZ f;

    if( (*(m->pb+rowpivot  *m->cols+colpivot*C2   ))
                           ||
        (*(m->pb+rowpivot  *m->cols+colpivot*C2+C1)) )
     {
      for(colp = (m->cols/C2)-1 ; colp > -1 ; colp--)
        {
         f = gfpivot_Z(m, rowpivot, colpivot, colp, rown_mns);

         (*(m->pb+rown_mns  *m->cols+colp*C2   )) = f.r;
         (*(m->pb+rown_mns  *m->cols+colp*C2+C1)) = f.i;
        }
      }
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
int gcpivotnt0_mZ(
PmZ mA,
int rowpivot,
int colpivot)
{
int rowunderp;
int coeff0 = 1;

  if(!(*(mA->pb+rowpivot *mA->cols+colpivot*C2   ))
                       &&
     !(*(mA->pb+rowpivot *mA->cols+colpivot*C2+C1)) )
  {
      coeff0 = 0;
   rowunderp = rowpivot + 1;
   do
   {
    if( (*(mA->pb+rowunderp *mA->cols+colpivot*C2  ))
                         ||
        (*(mA->pb+rowunderp *mA->cols+colpivot*C2+C1)) )
    {
     swap_r_Z(mA,rowpivot,rowunderp);
     rowunderp = mA->rows;
     coeff0 = 1;
    }
    rowunderp++;
   }
   while(rowunderp < mA->rows);
  }

return(coeff0);
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  On a column.                                                      */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gcpivot_mZ(
PmZ  m,
int   rowpivot,
int   colpivot
)
{
int      rown_mns;

     gcpivotnt0_mZ(m,rowpivot,colpivot);


     for(rown_mns = rowpivot+1; rown_mns < (m->rows); rown_mns++)
        {
          while( (!(*(m->pb+rowpivot  *m->cols+colpivot*C2   ))
                                &&
                  !(*(m->pb+rowpivot  *m->cols+colpivot*C2+C1)))
                                &&
                      (colpivot < m->cols/C2)
               )
               {
                colpivot++;
               };

         grpivot_mZ(m, rowpivot, colpivot,rown_mns);
        }
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :  .                                                                 */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void gdpivot_mZ(
PmZ  m
)
{
int      rowpivot;

     for(rowpivot = 0; rowpivot < (m->rows)-1  ;rowpivot++)
         gcpivot_mZ(m, rowpivot,rowpivot);

}




