/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ innerprod_Z(
PmZ mu,
PmZ mv
)
{
complexZ InnerProduct;

  if (mu->rows == 1             &&
      mu->cols == mv->rows * C2 &&
      mv->cols == C2
     )
     {
      InnerProduct = uv_uv_Z(mu,mv);
     }
    else if
     (mu->rows == 1        &&
      mv->rows == 1        &&
      mu->cols == mv->cols
     )
     {
      InnerProduct = uv_uvT_Z(mu,mv);
     }
    else if
     (mu->rows == mv->rows &&
      mu->cols == mv->cols &&
      mu->cols == C2
     )
     {
      InnerProduct = uv_uTv_Z(mu,mv);
     }
    else if
     (mu->rows * C2 == mv->cols &&
      mu->cols      == C2   &&
      mv->rows      == 1
     )
     {
      InnerProduct = uv_uTvT_Z(mu,mv);
     }
     else
     {
      printf(" innerprod() error.\n\n");

      printf("\nPress Return to continue\n");
      getchar();
      exit(1);
     }


  return(InnerProduct);
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ normP2_Z(
PmZ mu
)
{
complexZ NormP2;

         NormP2 = innerprod_Z(mu,mu);

  return(NormP2);
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE norm_Z(
PmZ mu,
int ru
)
{
complexZ NormP2;

MAT_TYPE pT[MXR][MXC]; mZ mT ={MXR,MXC,&pT[0][0]};

         mT.rows = 1;  mT.cols = mu->cols;

            copy_r_Z(mu,ru, &mT,0);
            NormP2 = innerprod_Z(&mT,&mT);

return(sqrt(NormP2.r));
}

/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
MAT_TYPE norm_c_Z(
PmZ mu
)
{
complexZ NormP2;

         NormP2 = innerprod_Z(mu,mu);

  return( (sqrt(NormP2.r)) );
}


/* --------------------------------- FUNCTION ------------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
complexZ distanceP2_Z(
PmZ mu,
PmZ mv
)
{
complexZ DistanceP2;

MAT_TYPE pu_mns_v [MXR][MXC*C2];mZ mu_mns_v={MXR, MXC*C2,&pu_mns_v[0][0]};

       mu_mns_v.rows = mu->rows;
       mu_mns_v.cols = mu->cols;

      sub_mZ(mu,mv,&mu_mns_v);

  DistanceP2 = normP2_Z(&mu_mns_v);

  return(DistanceP2);
}


