/* .h                        free ware  http://groups.yahoo.com/group/mathc/  */

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void Gram_Schimdt_mZ(
PmZ mu,
PmZ mv)
{
int a;
int n;
int m;

MAT_TYPE pbvT[MXR][MXC];mZ mvT ={MXR,MXC,&pbvT[0][0]};

   mvT.rows = 1;          mvT.cols = mu->cols;

        if(mu->rows > mu->cols/2)
    {
     printf("\n Gram_Schimdt_mZ() error - ");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }


   a = mu->rows;
   copy_r_Z(mu,0,mv,0);
   for(n=1 ; n<a; n++)
     for(m=0 ; m<n; m++)
      {
         if(!m){  copy_r_Z(mu,n, mv,        n);}
               projwn_r_mZ(mv,n, mv, m,&mvT,0);
                  sub_r_mZ(mv,n,&mvT,0, mv,n);
       }
}


/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void Gram_Schimdt_normalize_mZ(
PmZ mu,
PmZ mv)
{
int a;
int n;
int m;
MAT_TYPE      Norm;
MAT_TYPE   invNorm;
complexZ invNormT;

MAT_TYPE pbvT[MXR][MXC];mZ mvT ={MXR,MXC,&pbvT[0][0]};

   mvT.rows = 1;          mvT.cols = mu->cols;

     if(mu->rows > mu->cols/2)
    {
     printf("\n Gram_Schimdt_normalize_mZ() error - ");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }

   a = mu->rows;
   copy_r_Z(mu,0,mv,0);
   for(n=1 ; n<a; n++)
     for(m=0 ; m<n; m++)
      {
         if(!m){  copy_r_Z(mu,n, mv,        n);}
               projwn_r_mZ(mv,n, mv, m,&mvT,0);
                  sub_r_mZ(mv,n,&mvT,0, mv,n);
       }

  for(n=0 ; n<a; n++)
     {
         Norm = norm_Z(mv,n);
      invNorm = 1./(Norm);
      invNormT = init_Z(invNorm,0);
      mul_r_Z(mv,n,invNormT);
     }
}

/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* -------------------------------------------------------------------------- */
void QR_mZ(
PmZ A,
PmZ Q,
PmZ R
)
{
int a;
int n;
int m;
MAT_TYPE Norm;
MAT_TYPE invNorm;
complexZ invNormT;
complexZ z;

MAT_TYPE pbQT [MXR][MXC];mZ QT ={MXR,MXC,&pbQT   [0][0]};
MAT_TYPE pbUT [MXR][MXC];mZ UT ={MXR,MXC,&pbUT   [0][0]};

MAT_TYPE pba_T[MXR][MXC];mZ  A_T ={MXR,MXC,&pba_T[0][0]};
MAT_TYPE pbQ_T[MXR][MXC];mZ mQ_T ={MXR,MXC,&pbQ_T[0][0]};
MAT_TYPE pbR_T[MXR][MXC];mZ mr_T ={MXR,MXC,&pbR_T[0][0]};

    A_T.rows = A->cols/2;            A_T.cols = A->rows*2;
   mQ_T.rows = Q->cols/2;           mQ_T.cols = Q->rows*2;
  mr_T.rows = R->cols/2;          mr_T.cols = R->rows*2;

     QT.rows = 1;                   QT.cols = A->rows*2;
     UT.rows = 1;                   UT.cols = A->rows*2;
/*
  if(A->rows > A->cols/2)
    {
     printf("\n QR_mZ() error - ");
     printf("\n Press return to continue");
     getchar();
     exit(1);
    }
*/
   transpose_mZ(A,&A_T);

   a = A->rows;
   copy_r_Z(&A_T,0,&mQ_T,0);
   for(n=1 ; n<a; n++)
     for(m=0 ; m<n; m++)
      {
         if(!m){  copy_r_Z( &A_T,n, &mQ_T,         n);}
               projwn_r_mZ(&mQ_T,n, &mQ_T, m,  &QT,0);
                  sub_r_mZ(&mQ_T,n,   &QT, 0,&mQ_T,n);
       }

  for(n=0 ; n<a; n++)
     {
         Norm = norm_Z(&mQ_T,n);
      invNorm = 1./(Norm);
      invNormT = init_Z(invNorm,0);
      mul_r_Z(&mQ_T,n,invNormT);
     }

  for(n=0; n<A_T.rows; n++)
      {
       copy_r_Z(&A_T,n, &UT,0);
       for(m=0; m<A_T.cols; m++, m++)
         {
           copy_r_Z(&mQ_T,m/2, &QT,0);
           z = innerprod_Z(&UT,&QT);
          *(mr_T.pb+n *mr_T.cols+m+0)  = z.r;
          *(mr_T.pb+n *mr_T.cols+m+1)  = z.i;
         }
       }

   transpose_mZ(&mQ_T,Q);
   transpose_mZ(&mr_T,R);
}


