
#include "tcloseness.h"

// dist1 and dist2 may change
double tclose_getSimilarValue(generalizedAllTable *genAllTable, int noOfDim, int noOfTuple, int noOfSenValue, int *dist1_org, int *dist2_org, int noOfRealElt1, int noOfRealElt2)
{
	int i;

	double returnValue;

	int index1, index2;

	double ratio;

	float distort1, distort2;

	int *dist1;
	int *dist2;

	float aSingleGenDistValue;

	dimension dim1;
	dimension dim2;

	index1 = 0;
	index2 = 0;

	dist1 = (int *) malloc(sizeof(int)*noOfSenValue);
	memcpy(dist1, dist1_org, sizeof(int)*noOfSenValue);

	dist2 = (int *) malloc(sizeof(int)*noOfSenValue);
	memcpy(dist2, dist2_org, sizeof(int)*noOfSenValue);


	// expand
	if (noOfRealElt1 > noOfRealElt2)
	{
		ratio = noOfRealElt1/((double) noOfRealElt2);
		for (i = 0; i < noOfSenValue; i++)
		{
			dist2[i] = (int) ( dist2[i]*ratio );
		}
	}
	else
	{
		ratio = noOfRealElt2/((double) noOfRealElt1);
		for (i = 0; i < noOfSenValue; i++)
		{
			dist1[i] = (int) ( dist1[i]*ratio );
		}
	}

	// calculate 
	returnValue = 0;
	while (1)
	{
		dim1.level = 0;
		dim1.value = index1;//dist1[index1];

		dim2.level = 0;
		dim2.value = index2;//dist2[index2];

		calculateDistanceBetweenDimension(&(genAllTable->genDimTable[noOfDim-1]), &(dim1), &(dim2), &distort1, &distort2);
		if (dist1[index1] < dist2[index2])
		{	
			///aSingleGenDistValue = genTable_getValue(dist1[index1], dist2[index2]);
			aSingleGenDistValue = distort1;
			returnValue += dist1[index1]*aSingleGenDistValue;

			dist2[index2] -= dist1[index1];

			index1++;
		}
		else if (dist1[index1] > dist2[index2])
		{
			//aSingleGenDistValue = genTable_getValue(dist1[index1], dist2[index2]);
			aSingleGenDistValue = distort1;
			returnValue += dist2[index2]*aSingleGenDistValue;

			dist1[index1] -= dist2[index2];

			index2++;
		}
		else
		{
			//aSingleGenDistValue = genTable_getValue(dist1[index1], dist2[index2]);
			aSingleGenDistValue = distort1;
			returnValue += dist2[index2]*aSingleGenDistValue;

			index1++;
			index2++;
		}

		if ((index1 >= noOfSenValue) || (index2 >= noOfSenValue))
		{
			break;
		}
	}

	returnValue /= noOfTuple;
	//returnValue /= noOfSenValue;

	free(dist1);
	free(dist2);

	return returnValue;
}

int *tclose_getWholeDist(data *aData)
{
	int *returnValue;

	int noOfSenValue, noOfDim, noOfTuple;

	int i;
	int aSenValue;

	tuple *aTuple;
	tuple *tupleList;

	noOfTuple = aData->noOfTuple;
	noOfDim = aData->noOfDim;

	tupleList = aData->tupleList;

	noOfSenValue = aData->dimSize[noOfDim-1];

	returnValue = (int *) malloc(sizeof(int)*noOfSenValue);
	memset(returnValue, 0, sizeof(int)*noOfSenValue);

	for (i = 0; i < noOfTuple; i++)
	{
		aTuple = &(tupleList[i]);
		aSenValue = aTuple->content[noOfDim-1].value;
		returnValue[aSenValue]++;
	}

	return returnValue;
}


int *tclose_getDistFromEqTuple(equivalenceTuple *eqTuple, data *aData, int noOfSenValue)
{
	int *returnValue;

	int i;

	int noOfMember;
	//dimension *senValue;

	int aSenValue;

	int *member;
	int noOfDim;

	int tupleID;


	returnValue = (int *) malloc(sizeof(int)*noOfSenValue);
	memset(returnValue, 0, sizeof(int)*noOfSenValue);

	noOfMember = eqTuple->noOfMember;
	//senValue = eqTuple->senValue;
	member = eqTuple->member;

	noOfDim = aData->noOfDim;

	for (i = 0; i < noOfMember; i++)
	{
		tupleID = member[i];
		aSenValue = aData->tupleList[tupleID].content[noOfDim-1].value;

		returnValue[aSenValue]++;
	}

	return returnValue;
}

